#!/usr/bin/php
<?
   // Report Engine Function Tests
   // $Id: testreportengine.php,v 1.1 2002/04/21 03:03:40 vdanen Exp $
   //
   // (C) 2002 by John Gatewood Ham
   //
   // This program is free software; you can redistribute it and/or modify
   // it under the terms of the GNU General Public License as published by
   // the Free Software Foundation; either version 2 of the License, or
   // (at your option) any later version.
   //
   // This program is distributed in the hope that it will be useful,
   // but WITHOUT ANY WARRANTY; without even the implied warranty of
   // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   // GNU General Public License for more details.
   //
   // You should have received a copy of the GNU General Public License
   // along with this program; if not, write to the Free Software
   // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   //
  $blitz = "Once upon a time there was a young green dragon named Blitz who lived in Bavaria.  He was healthy and had learned to get along with the humans in his area by collecting a tax in return for ariel support in battles.  He used the tax to buy livestock for food, so he never had to steal anything.  His life was almost perfect.  However, one thing was lacking, namely a Mrs. Blitz.  Since the women dragons from his region were all so familiar, Blitz decided to travel abroad to find the right mate. (C) 2002 by John Gatewood Ham";
  include("include/reportengine.php");

// Test 1
// Test primitive line breaking
  report_init(10, 80, 0);
  for ($j = 0; $j < 13; $j += 1) {
     report_que_line("Hi there $j");
  }
  for ($j = 0; $j < 18; $j += 1) {
     report_que_line("Hi there $j, I am a very long line and will cause some page break action if I'm lukcy, but I'm not really sure what will happen or whatever.");
  }
  for ($j = 0; $j < 18; $j += 1) {
     report_flowtext("Hi there $j, I am a very long line and will cause some page break action if I'm lukcy, but I'm not really sure what will happen or whatever.",$j);
  }
  report_finish();

// Test 2
// Test flow text line breaking, keeps with 5 column margins
  report_init(10, 80, 0, 0, "Testing 2", 5, 5);
  for ($j = 0; $j < 9; $j += 1) {
     report_que_line("This is line $j");
  }
  report_start_keep();
  for ($j = 9; $j < 14; $j += 1) {
     report_que_line("This is kept line $j");
  }
  report_end_keep();
  report_flowtext("This is a pagebreak wrapping line 14, and it is a very long line indeed, in fact it is more than the 80 byte width (minus 10 margin bytes)");
  for ($j = 15; $j < 18; $j += 1) {
     report_que_line("This is unkept line $j");
  }
  report_que_line("This is a pagebreak wrapping line $j, and it is a very long line indeed, in fact it is more than the 80 byte width (minus 10 margin bytes)");
  report_que_line("This is line 20");
  report_start_keep();
  report_flowtext($blitz);
  report_end_keep();
  report_finish();

// Test 3
// Test flow text line breaking, keeps with 0 column margins,
// use formfeeds, do ms-dos newlines
  report_init(10, 80, 1, 1, "Testing 3", 0, 0);
  for ($j = 0; $j < 9; $j += 1) {
     report_que_line("This is line $j");
  }
  report_start_keep();
  for ($j = 9; $j < 14; $j += 1) {
     report_que_line("This is kept line $j");
  }
  report_end_keep();
  report_flowtext("This is a pagebreak wrapping line 14, and it is a very long line indeed, in fact it is more than the 80 byte width (minus 0 margin bytes) which aren't very crticial anyway as you have surmised by now");
  for ($j = 15; $j < 18; $j += 1) {
     report_que_line("This is unkept line $j");
  }
  report_que_line("This is a pagebreak wrapping line $j, and it is a very long line indeed, in fact it is more than the 80 byte width (minus 10 margin bytes)");
  report_que_line("This is line 20");
  report_start_keep();
  report_flowtext($blitz);
  report_end_keep();
  report_finish();
?>
