<?
  // Anthill
  // $Id: buglist.php,v 1.41 2003/08/27 21:26:35 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['type']))     { $type     = $_REQUEST['type']; }     else { $type     = NULL; }
  if (isset($_REQUEST['search']))   { $search   = $_REQUEST['search']; }   else { $search   = NULL; }
  if (isset($_REQUEST['allclass'])) { $allclass = $_REQUEST['allclass']; } else { $allclass = NULL; }
  if (isset($_REQUEST['myclass']))  { $myclass  = $_REQUEST['myclass']; }  else { $myclass  = NULL; }
  if (isset($_REQUEST['who']))      { $who      = $_REQUEST['who']; }      else { $who      = NULL; }
  if (isset($_REQUEST['rwho']))     { $rwho     = $_REQUEST['rwho']; }     else { $rwho     = NULL; }
  if (isset($_REQUEST['product']))  { $product  = $_REQUEST['product']; }  else { $product  = NULL; }
  if (isset($_REQUEST['vproduct'])) { $vproduct = $_REQUEST['vproduct']; } else { $vproduct = NULL; }
  if (isset($_REQUEST['sversion'])) { $sversion = $_REQUEST['sversion']; } else { $sversion = NULL; }
  if (isset($_REQUEST['eversion'])) { $eversion = $_REQUEST['eversion']; } else { $eversion = NULL; }
  if (isset($_REQUEST['sort']))     { $sort     = $_REQUEST['sort']; }     else { $sort     = "bid"; }
  if (isset($_REQUEST['order']))    { $order    = $_REQUEST['order']; }    else { $order    = "ASC"; }
  if (isset($_REQUEST['sdate']))    { $sdate    = $_REQUEST['sdate']; }    else { $sdate    = NULL; }
  if (isset($_USER['uid']))         { $uid      = $_USER['uid']; }         else { $uid      = NULL; }

  if (isset($type) || isset($search)) {
    d_StartPage(gettext("Bug List"));
    if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
    d_DrawNav($user['uname']);

    d_DrawHeader(gettext("Bug List"));

  if ($_SERVER['REQUEST_METHOD'] == "GET") { // reconstruct our query string without sort order
    $token = strtok($_SERVER['QUERY_STRING'], "&");
    $c     = 0;
    while ($token) {
      if (!ereg("^sort.*", $token)) {
        if (!ereg("^order.*", $token)) {
        if ($c == 0) {
          $string = $token;
        } else {
          $string = $string . "&" . $token;
        }
        }
      }
      $c++;
      $token = strtok("&");
    }
  } elseif ($_SERVER['REQUEST_METHOD'] == "POST") { // reconstruct our query string without sort order
    $c = 0;
    for ($HTTP_POST_VARS; $k=key($HTTP_POST_VARS); next($HTTP_POST_VARS)) {
      if ($k != "sort") {
        if ($k != "order") {
        if ($HTTP_POST_VARS[$k] != "") {
          if ($c == 0) {
            $string = $k . "=" . $HTTP_POST_VARS[$k];
          } else {
            $string = $string . "&" . $k . "=" . $HTTP_POST_VARS[$k];
          }
        }
        }
      }
      $c++;
    }
  }

  switch($type) {
    case "all":
      if ($allclass == "all") {
        if (isset($search)) {
          $msg     = sprintf(gettext("Searching for all bugs containing search phrase \"<b>%s</b>\""), $search);
        } else {
          $query  = "";
          $msg    = gettext("Searching for all bugs...");
        }
      } else {
        $query = "WHERE status = '$allclass'";
        $db->query("SELECT * FROM status_d WHERE id = '$allclass'");
        $db->next_record();
        $msg   = sprintf(gettext("Searching for all bugs of status %s..."), $db->record['name']);
        $db->free();
      }
      break;
    case "unres":
      $query = "WHERE status NOT IN (4,6)";
      $msg   = gettext("Searching for all unresolved bugs...");
      break;
    case "mine":
      if ($myclass == "all") {
        $query = "WHERE assigned = '$uid'";
        $msg   = gettext("Searching for all of your bugs...");
      } elseif ($myclass == "new") {
        $query = "WHERE assigned= '$uid' AND status NOT IN (4,6,7)";
        $msg   = gettext("Searching for all of your unresolved bugs...");
      } else {
        $query = "WHERE assigned = '$uid' AND status = '$myclass'";
        $db->query("SELECT * FROM status_d WHERE id = '$myclass'");
        $db->next_record();
        $msg   = sprintf(gettext("Searching for all of your bugs of status %s..."), $db->record['name']);
        $db->free();
      }
      break;
    case "user":
      $query = "WHERE assigned = '$who'";
      $db->query("SELECT * FROM users WHERE uid = '$who'");
      $db->next_record();
      $msg   = sprintf(gettext("Searching for all bugs belonging to %s..."), $db->record['email']);
      $db->free();
      break;
    case "reporter":
      $query = "WHERE reporter = '$uid'";
      $db->query("SELECT * FROM users WHERE uid = '$uid'");
      $db->next_record();
      $msg   = sprintf(gettext("Searching for all bugs reported by %s..."), $db->record['email']);
      $db->free();
      break;
    case "reporternew":
      $query = "WHERE reporter = '$uid' AND status = '1'";
      $db->query("SELECT * FROM users WHERE uid = '$uid'");
      $db->next_record();
      $msg   = sprintf(gettext("Searching for all new bugs reported by %s..."), $db->record['email']);
      $db->free();
      break;
    case "reportby":
      $query = "WHERE reporter = '$rwho'";
      $db->query("SELECT * FROM users WHERE uid = '$rwho'");
      $db->next_record();
      $msg   = sprintf(gettext("Searching for all bugs reported by %s..."), $db->record['email']);
      $db->free();
      break;
    case "product":
      if ($product != "") {
        $query = "WHERE product = '$product'";
        $db->query("SELECT * FROM products WHERE pid = '$product'");
        $db->next_record();
        $msg = sprintf(gettext("Searching for all bugs of product %s..."), $db->record['name']);
        $db->free();
      } else {
        $query = "";
        $msg = gettext("Searching for all bugs of all products...");
      }
      break;
    case "versiondiff":
      d_AskVersion($vproduct);
      $exit = 1;
      break;
    case "bydate":
      $query = "WHERE creation >= '$sdate'";
      $msg   = sprintf(gettext("Searching for all bugs reported since %s"), d_getTime($sdate));
      break;
    case "resdate":
      $query = "WHERE modified >= '$sdate' AND (status = '4' OR status = '6')";
      $msg   = sprintf(gettext("Searching for all bugs RESOLVED or CLOSED since %s"), d_getTime($sdate));
      break;
    default:
      $msg = gettext("No action specified.");
      $exit = 1;
      break;
  }

  if (isset($exit)) { print($msg); d_DrawFooter(); exit; }

  print("<p>$msg</p>");

  $url  = $PHP_SELF . "?" . $string;
  $up   = "<img src=\"" . $_CONF['webroot'] . $_CONF['imgdir'] . "/arrow_up_blue.gif\" border=\"0\" alt=\"^\">";
  $down = "<img src=\"" . $_CONF['webroot'] . $_CONF['imgdir'] . "/arrow_down_blue.gif\" border=\"0\" alt=\"v\">";

?>
  <table cellpadding="0" cellspacing="0" border="0" width="100%">
    <tr bgcolor="<? print($config['barcol1']); ?>">
      <td>
        <b><? print(gettext("Bug")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=bid&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=bid&order=DESC\">$down"); ?></a>
      </td>
      <td>
        <b><? print(gettext("Product")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=prod&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=prod&order=DESC\">$down"); ?></a>
      </td>
      <td>
        <b><? print(gettext("Component")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=comp&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=comp&order=DESC\">$down"); ?></a>
      </td>
      <td>
        <b><? print(gettext("Priority")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=pri&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=pri&order=DESC\">$down"); ?></a>
      </td>
      <td>
        <b><? print(gettext("Owner")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=own&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=own&order=DESC\">$down"); ?></a>
      </td>
      <td>
        <b><? print(gettext("Status")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=stat&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=stat&order=DESC\">$down"); ?></a>
      </td>
      <td>
        <b><? print(gettext("Resolution")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=res&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=res&order=DESC\">$down"); ?></a>
      </td>
      <td>
        <b><? print(gettext("Summary")); ?>#</b>&nbsp;
           <a href="<? print($url . "&sort=summ&order=ASC\">$up"); ?></a>
           <a href="<? print($url . "&sort=summ&order=DESC\">$down"); ?></a>
      </td>
    </tr>
<?

  if (isset($search)) {
    $count = d_doSearchList($search, $sort, $order);
  } else {
    $count = d_doBugList($query, $sort, $order);
  }
?>

  </table>

  <br /><span class="text"><center><? print(sprintf(gettext("%s bugs found"), $count)); ?>.</span></center>

  <p><? print(gettext("Return to <a href=\"query.php\">Bug list</a>.")); ?></p>

<?
    d_DrawFooter();
    exit;
  }

  // generate version diffs
  if (isset($sversion) || isset($eversion)) {
    d_StartPage(gettext("Bug List"));
    if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
    d_DrawNav($user['uname']);

    d_DrawHeader(gettext("Bug List"));
    $db->query("SELECT * FROM products WHERE (pid = '$product') AND (deleted = '0')");
    $db->next_record();
    $pname = $db->record['name'];
    $db->free();
    print("<p>" . sprintf(gettext("Listing FIXED bugs for product \"%s\" between versions %s and %s"),$pname,$sversion,$eversion) . "</p>");
    $db->query("SELECT * FROM bugs WHERE (fixedver >= '$sversion') AND (fixedver <= '$eversion') AND (product = '$product') ORDER BY fixedver");
    print("<table cellpadding=\"0\" cellspacing=\"1\" border=\"0\" width=\"100%\">");
    print("<tr><td><b>" . gettext("Bug #") . "</b></td>");
    print("<td><b>" . gettext("Product") . "</b></td>");
    print("<td><b>" . gettext("Fixed Version") . "</b></td>");
    print("<td><b>" . gettext("Summary") . "</b></td></tr>");
    while ($db->next_record()) {
      d_DumpVdiff($pname, $db->record);
    }
    print("</table>");
    d_DrawFooter();
    exit;
  }

  header("Location: " . $_CONF['webroot'] . "/query.php");
?>
