<?
  // Anthill
  // $Id: editcomponents.php,v 1.25 2003/09/24 06:15:36 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['action']))      { $action      = $_REQUEST['action']; }      else { $action      = NULL; }
  if (isset($_REQUEST['pid']))         { $pid         = $_REQUEST['pid']; }         else { $pid         = NULL; }
  if (isset($_REQUEST['cid']))         { $cid         = $_REQUEST['cid']; }         else { $cid         = NULL; }
  if (isset($_REQUEST['name']))        { $name        = $_REQUEST['name']; }        else { $name        = NULL; }
  if (isset($_REQUEST['owner']))       { $owner       = $_REQUEST['owner']; }       else { $owner       = NULL; }
  if (isset($_REQUEST['description'])) { $description = $_REQUEST['description']; } else { $description = NULL; }

  d_StartPage(gettext("Select Component"));

  if (!do_checkacs($_USER['access'])) exit;

  d_DrawNav($_USER['uname']);

  // form to add new component
  if ($action == "add") {
    d_DrawHeader(gettext("Add Component"));
    d_DrawEditComp("insert",0,$pid);
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // insert new component
  if ($action == "insert") {
    d_DrawHeader(gettext("Add Component"));
    // make sure a component by this name doesn't already exist
    $db->query("SELECT * FROM components WHERE (name = '$name') AND (deleted = '0') AND (product = '$pid')");
    if ($db->num_rows() > 0) {
      print("<p>" . gettext("A component by this name already exists.") . "</p>");
    } else {
      if ($name == "") {
        print("<p>" . gettext("ERROR: You submitted an empty field.") . "</p>");
      } else {
        // clean up the autocc string
        $tmp    = explode(",",$autocc);
        $x      = count($tmp);
        for ($i=0; $i<$x; $i++) {
          $tmp[$i] = trim($tmp[$i]);
        }
        $autocc = implode($tmp,", ");
        $query  = "INSERT INTO components (cid, name, product, ";
        $query .= "owner, description, autocc) VALUES ";
        $query .= "(NULL, ";
        $query .= "'" . addslashes(htmlspecialchars($name)) . "', '" . $pid . "', ";
        $query .= "'" . addslashes(htmlspecialchars($owner)) . "', ";
        $query .= "'" . addslashes(htmlspecialchars($description)) . "',";
        $query .= "'" . addslashes(htmlspecialchars($autocc)) . "')";
        $db->query($query);
        $db->free();
        print("<span class=\"text\"><center>" . gettext("Component added successfully.") . "</center></span>");
      }
    }
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // form to delete component
  if ($action == "del") {
    d_DrawHeader(gettext("Delete Component"));
    $db->query("SELECT * FROM components WHERE cid = '$cid'");
    $db->next_record();
    $db->free();
?>
  <form method="post" action="editcomponents.php">
  <p><? print(sprintf(gettext("Are you sure you want to delete the component <b>%s</b>?"), stripslashes($db->record['name']))); ?>
  </p>
  <input type="submit" value="<? print(gettext("Delete")); ?>">
  <input type="hidden" name="cid" value="<? print($cid); ?>">
  <input type="hidden" name="pid" value="<? print($pid); ?>">
  <input type="hidden" name="action" value="delete">
  </form>
<?
    d_DrawFooter();
    exit;
  }

  // perform delete
  if ($action == "delete") {
    d_DrawHeader(gettext("Delete Component"));
    $db->query("UPDATE components SET deleted = '1' WHERE cid = '$cid'");
    $db->free();
    print("<span class=\"text\"><center>" . gettext("Component removed.") . "</center></span>");
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid)) . "<br />";
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // form to edit component
  if ($action == "edit") {
    d_DrawHeader(gettext("Change Component"));
    d_DrawEditComp("change",$cid,$pid);
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // change component
  if ($action == "change") {
    d_DrawHeader(gettext("Change Component"));
    // clean up the autocc string
    $tmp    = explode(",",$autocc);
    $x      = count($tmp);
    for ($i=0; $i<$x; $i++) {
      $tmp[$i] = trim($tmp[$i]);
    }
    $autocc = implode($tmp,", ");
    $query  = "UPDATE components SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $db->query($query);
    $db->free();
    $query  = "UPDATE components SET owner = '" . addslashes(htmlspecialchars($owner)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $db->query($query);
    $db->free();
    $query  = "UPDATE components SET description = '" . addslashes(htmlspecialchars($description)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $db->query($query);
    $db->free();
    $query  = "UPDATE components SET autocc = '" . addslashes(htmlspecialchars($autocc)) . "' ";
    $query .= "WHERE cid = '$cid'";
    $db->query($query);
    $db->free();
    print("<span class=\"text\"><center>" . gettext("Component changed.") . "</center></span>");
    print("<p>" . sprintf(gettext("Return to <a href=\"editcomponents.php?pid=%s\">components</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // default action
  d_DrawHeader(gettext("Select Component"));

  $db2         = new db_Sql();
  $db2->host   = $_CONF['db_host'];
  $db2->dbase  = $_CONF['db_name'];
  $db2->user   = $_CONF['db_user'];
  $db2->passwd = $_CONF['db_pw'];
  $db2->connect();

  $db->query("SELECT * FROM components WHERE (product = '$pid') AND (deleted = '0') ORDER BY name");

?>
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr bgcolor="<? print($config['barcol1']); ?>">
      <td width="20%">
        <? print(gettext("Component")); ?>
      </td>
      <td width="50%">
        <? print(gettext("Description")); ?>
      </td>
      <td width="20%">
        <? print(gettext("Initial Owner")); ?>
      </td>
      <td width="10%">
        <? print(gettext("Action")); ?>
      </td>
    </tr>
<?
  while ($db->next_record()) {
    $cid = $db->record['cid'];
?>
    <tr>
      <td width="20%">
        <? print(sprintf("<a href=\"editcomponents.php?cid=%s&pid=%s&action=edit\">%s</a>",$cid,$pid,stripslashes($db->record['name']))); ?>  
      </td>
      <td width="50%">
        <? print(stripslashes($db->record['description'])); ?>  
      </td>
      <td width="20%">
        <? $db2->query("SELECT * FROM users WHERE uid = '" . $db->record['owner'] . "'");
           $db2->next_record();
           print(stripslashes($db2->record['email']));
           $db2->free();
        ?>  
      </td>
      <td width="10%">
        <? print(sprintf("<a href=\"editcomponents.php?cid=%s&pid=%s&action=del\">" . gettext("Delete") . "</a>",$cid,$pid)); ?>
      </td>
    </tr>
<?
  }
?>
    <tr>
      <td width="20%">
        <? print(gettext("Add a new component")); ?>
      </td>
      <td width="10%">
        <a href="editcomponents.php?pid=<? print($pid); ?>&action=add"><? print(gettext("Add")); ?></a>
      </td>
    </tr>
  </table>

<?
  print("<p>" . sprintf(gettext("Return to <a href=\"editproducts.php?pid=%s&action=edit\">products</a>"), $pid) . "<br />");
  print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
  print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
  d_DrawFooter();
?>
