<?
  // Anthill
  // $Id: editversions.php,v 1.22 2003/08/27 19:59:25 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['action'])) { $action = $_REQUEST['action']; } else { $action = NULL; }
  if (isset($_REQUEST['pid']))    { $pid    = $_REQUEST['pid']; }    else { $pid    = NULL; }
  if (isset($_REQUEST['name']))   { $name   = $_REQUEST['name']; }   else { $name   = NULL; }
  if (isset($_REQUEST['vid']))    { $vid    = $_REQUEST['vid']; }    else { $vid    = NULL; }

  d_StartPage(gettext("Select Version"));

  if (!do_checkacs($_USER['access'])) exit;

  d_DrawNav($_USER['uname']);

  // form to add new version
  if ($action == "add") {
    d_DrawHeader(gettext("Add Version"));
    d_DrawEditVer("insert",0,$pid);
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // insert new version
  if ($action == "insert") {
    d_DrawHeader(gettext("Add Version"));
    // check if version already exists
    $db->query("SELECT * FROM versions WHERE (name = '$name') AND (deleted = '0') AND (product = '$pid')");
    if ($db->num_rows() > 0) {
      print("<p>" . gettext("A version by this name already exists.") . "</p>");
    } else {
      if ($name == "") {
        print("<p>" . gettext("ERROR: You submitted an empty field.") . "</p>");
      } else {
        $query  = "INSERT INTO versions (vid, product, name) VALUES ";
        $query .= "(NULL, '" . $pid . "', '";
        $query .= addslashes(htmlspecialchars($name)) . "')";
        $db->query($query);
        $db->free();
        print("<span class=\"text\"><center>" . gettext("Version added successfully.") . "</center></span>");
      }
    }
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // form to delete version
  if ($action == "del") {
    d_DrawHeader(gettext("Delete Version"));
    $db->query("SELECT * FROM versions WHERE vid = '$vid'");
    $db->next_record();
    $db->free();
?>
  <form method="post" action="editversions.php">
  <p><? print(sprintf(gettext("Are you sure you want to delete the version <b>%s</b>?"), stripslashes($db->record['name']))); ?>
  </p>
  <input type="submit" value="<? print(gettext("Delete")); ?>">
  <input type="hidden" name="vid" value="<? print($vid); ?>">
  <input type="hidden" name="pid" value="<? print($pid); ?>">
  <input type="hidden" name="action" value="delete">
  </form>
<?
    d_DrawFooter();
    exit;
  }

  // perform delete
  if ($action == "delete") {
    d_DrawHeader(gettext("Delete Version"));
    $db->query("UPDATE versions SET deleted = '1' WHERE vid = '$vid'");
    $db->free();
    print("<span class=\"text\"><center>" . gettext("Version removed.") . "</center></span>");
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // form to edit version
  if ($action == "edit") {
    d_DrawHeader(gettext("Change Version"));
    d_DrawEditVer("change",$vid,$pid);
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // change version
  if ($action == "change") {
    d_DrawHeader(gettext("Change Version"));
    $query  = "UPDATE versions SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE vid = '$vid'";
    $db->query($query);
    $db->free();
    print("<span class=\"text\"><center>" . gettext("Version changed.") . "</center></span>");
    print("<p>" . sprintf(gettext("Return to <a href=\"editversions.php?pid=%s\">versions</a>."), $pid) . "<br />");
    print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // default action
  d_DrawHeader(gettext("Select Version"));
  $db->query("SELECT * FROM versions WHERE (product = '$pid') AND (deleted = '0')");

?>
  <table border="0" cellpadding="0" cellspacing="0" width="30%">
    <tr bgcolor="<? print($config['barcol1']); ?>">
      <td width="20%">
        <? print(gettext("Version")); ?>
      </td>
      <td width="10%">
        <? print(gettext("Action")); ?>
      </td>
    </tr>
<?
  while ($db->next_record()) {
    $vid = $db->record['vid'];
?>
    <tr>
      <td width="20%">
        <? print(sprintf("<a href=\"editversions.php?vid=%s&pid=%s&action=edit\">%s</a>",$vid,$pid,stripslashes($db->record['name']))); ?>  
      </td>
      <td width="10%">
        <? print(sprintf("<a href=\"editversions.php?vid=%s&pid=%s&action=del\">" . gettext("Delete") . "</a>",$vid,$pid)); ?>
      </td>
    </tr>
<?
  }
  $db->free();
?>
    <tr>
      <td width="20%">
        <? print(gettext("Add a new version")); ?>
      </td>
      <td width="10%">
        <a href="editversions.php?pid=<? print($pid); ?>&action=add"><? print(gettext("Add")); ?></a>
      </td>
    </tr>
  </table>

<?
  print("<p>" . sprintf(gettext("Return to <a href=\"editproducts.php?pid=%s&action=edit\">products</a>"), $pid) . "<br />");
  print(gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
  print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
  d_DrawFooter();
?>
