<?
  // Anthill site include
  // $Id: site.inc.php,v 1.50 2003/09/30 21:21:42 vdanen Exp $

  ###########################################################################
  # 
  # DO NOT TOUCH ANYTHING BELOW!!  DOING SO CAN RENDER YOUR SYSTEM UNUSABLE!!
  # 
  ###########################################################################

  // set to E_ALL for debugging
  error_reporting(0);

  define("_VERSION","0.2.4");
  define("_NAME","Anthill");

  $rtmpldir   = $_CONF['root'] . $_CONF['tmpldir'];
  $wtmpldir   = $_CONF['webroot'] . $_CONF['tmpldir'];

  if(file_exists($_CONF['incdir'] . "/user.inc.php")) { include_once($_CONF['incdir'] . "/user.inc.php"); }
  if(file_exists($_CONF['incdir'] . "/functions.inc.php")) { include_once($_CONF['incdir'] . "/functions.inc.php"); }
  if(file_exists($_CONF['incdir'] . "/" . $_CONF['db_type'] . ".class.php")) { include_once($_CONF['incdir'] . "/" . $_CONF['db_type'] . ".class.php"); }

  // primary database connection
  $db         = new db_Sql();
  $db->host   = $_CONF['db_host'];
  $db->dbase  = $_CONF['db_name'];
  $db->user   = $_CONF['db_user'];
  $db->passwd = $_CONF['db_pw'];
  $db->connect();

  $db->query("SELECT * FROM config");
  $config     = array();
  while ($db->next_record()) {
    $config[$db->record['name']] = $db->record['value'];
  }
  $db->free();

  // set language
  $BROWSER_LANGUAGE = "";
  if ($_SERVER['HTTP_ACCEPT_LANGUAGE']) {
    $tmp = strtok($_SERVER['HTTP_ACCEPT_LANGUAGE'], ",");
    while ($tmp) {
      while ($tmp[0] == " ") $tmp = substr($tmp, 1);
      $BROWSER_LANGUAGE = $BROWSER_LANGUAGE . ereg_replace("-","_",$tmp) . ":";
      $tmp = strtok(",");
    }
  }
  if (substr($BROWSER_LANGUAGE, 0, 2) != "en") {
    putenv(sprintf("LANGUAGE=%s",$BROWSER_LANGUAGE));
    putenv("LC_ALL=UTF-8");
    // setlocale(LC_ALL, $BROWSER_LANGUAGE); // this may be necessary?
    setlocale(LC_ALL, "");
    bindtextdomain("Anthill", $_CONF['root'] . $_CONF['langdir']);
    textdomain("Anthill");
  }

  // session checking; is user logged in?

  $_USER = do_sessioncheck();
  $user  = $_USER; // compatability

  // handle persistent cookies
  if (!isset($_COOKIE[$_CONF['cookie_name']]) || !isset($_COOKIE['password'])) {
    // either their cookie expired or they are new
    $cookietime = do_getusercookietimeout();
    if (!empty($cookietime)) {
      // persistent cookie
      setcookie($_CONF['cookie_name'],$_USER['uid'],time() + $cookietime,$_CONF['cookie_path'],$_CONF['cookie_domain'],$_CONF['cookie_secure']);
      setcookie('password',$_USER['passwd'],time() + $cookietime,$_CONF['cookie_path'],$_CONF['cookie_domain'],$_CONF['cookie_secure']);
    }
  } else {
    $userid = $_COOKIE[$_CONF['cookie_name']];
    if ($userid) {
      $user_logged_in = 1;
      // create new session
      $userdata       = do_getuserdatafromid($userid);
      $_USER          = $userdata;
    }
  }

  if(file_exists(sprintf("%s/%s/theme.php", $rtmpldir, $config['theme']))) {
    include_once(sprintf("%s/%s/theme.php", $rtmpldir, $config['theme']));
  }

?>