<?
  // Anthill
  // $Id: postbug.php,v 1.29 2003/08/27 20:56:38 vdanen Exp $
  
  include("include.php");

  // set variables
  if (isset($_REQUEST['reporter']))  { $reporter  = $_REQUEST['reporter']; }  else { $reporter  = NULL; }
  if (isset($_REQUEST['product']))   { $product   = $_REQUEST['product']; }   else { $product   = NULL; }
  if (isset($_REQUEST['version']))   { $version   = $_REQUEST['version']; }   else { $version   = NULL; }
  if (isset($_REQUEST['component'])) { $component = $_REQUEST['component']; } else { $component = NULL; }
  if (isset($_REQUEST['prior']))     { $prior     = $_REQUEST['prior']; }     else { $prior     = NULL; }
  if (isset($_REQUEST['sever']))     { $sever     = $_REQUEST['sever']; }     else { $sever     = NULL; }
  if (isset($_REQUEST['status']))    { $status    = $_REQUEST['status']; }    else { $status    = NULL; }
  if (isset($_REQUEST['assigned']))  { $assigned  = $_REQUEST['assigned']; }  else { $assigned  = NULL; }
  if (isset($_REQUEST['shortdesc'])) { $shortdesc = $_REQUEST['shortdesc']; } else { $shortdesc = NULL; }
  if (isset($_REQUEST['longdesc']))  { $longdesc  = $_REQUEST['longdesc']; }  else { $longdesc  = NULL; }
  if (isset($_REQUEST['url']))       { $url       = $_REQUEST['url']; }       else { $url       = NULL; }

  d_StartPage(gettext("Posting Bug"));
  d_DrawNav($_USER['uname']);
  d_DrawHeader(gettext("Posting Bug"));

  if (!isset($_USER['uid'])) {
    print("<p>" . gettext("You must login to access this page.") . "</p>");
    d_DrawFooter();
    exit;
  }    

  // reporter (uid), product (pid), version (vid), component (cid)
  // priority, severity, assigned (uid), shortdesc, longdesc

  // get the default status
  $db->query("SELECT * FROM status_d WHERE s_def = '1'");
  $db->next_record();
  $status = $db->record['id'];
  $db->free();

  if ($assigned == 0) { // chosen to assign to component owner
    $db->query("SELECT * FROM components WHERE cid = '$component'");
    $db->next_record();
    $assigned = $db->record['owner'];
    $db->free();
  }
  
  $db->query("SELECT * FROM users WHERE uid = '$assigned'");
  $db->next_record();
  if ($db->record['access'] < $config['devac']) { // assigned user's access is lower than developer access
    print("<span class=\"text\"><center>" . gettext("ERROR: You have assigned the bug to someone unauthorized to own bugs.") . "</center></span><br />");
    d_drawFooter();
    exit;
  }

  if ($shortdesc == "") { // no short description entered
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to include a summary of the bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
  }

  if ($longdesc == "") { // no long description entered
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to include a description of the bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
  }

  if ($version == 0) { // no version chosen
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to select a version for this bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
  }

  if ($component == 0) { // no component chosen
    print("<span class=\"text\"><center>" . gettext("ERROR: You need to select a component for this bug.") . "</center></span><br />");
    d_drawFooter();
    exit;
  }

  // create the autocc string
  $query    = "SELECT autocc from components WHERE cid = '$component'";
  $db->query($query);
  $db->next_record();
  $autocc   = $db->record['autocc'];
  $db->free();
  if ($config['autocc'] != "") {
    if ($autocc != "") {
      $autocc = $config['autocc'] . ", " . $autocc;
    } else {
      $autocc = $config['autocc'];
    }
  }
  $creation = date("YmdHis");  // use same format as timestamp
  $query    = "INSERT INTO bugs (bid, assigned, severity, status, creation, ";
  $query   .= "modified, shortdesc, priority, product, reporter, version, ";
  $query   .= "component, resolution, cc, private, url) VALUES ";
  $query   .= "(NULL,'$assigned','$sever','$status', ";
  $query   .= "'$creation', NULL, '" . addslashes($shortdesc) . "', ";
  $query   .= "'$prior','$product','$reporter','$version','$component', ";
  $query   .= "NULL, '$autocc', ". $config['defpriv'] . ", ";
  $query   .= "'" . trim(addslashes($url)) . "')";
  $db->query($query);
  $db->free();
  $db->query("SELECT * FROM bugs ORDER BY bid DESC");
  $db->next_record();
  $bugnum   = $db->record['bid'];
  $db->free();
  $query    = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
  $query   .= "(NULL,'$bugnum','$reporter',NULL,0,";
  $query   .= "'" . addslashes($longdesc) . "')";
  $db->query($query);
  $db->free();

  d_doDiff($bugnum);

  print("<p><b>" . sprintf(gettext("Bug #%s posted"), $bugnum) . ".</b></p>");
  print("<p><a href=\"query.php?bug=$bugnum\">" . sprintf(gettext("Back to Bug #%s"), $bugnum) . "</a>&nbsp;&nbsp;&nbsp;&nbsp;");
  print("<a href=\"enterbug.php\">" . gettext("Enter another bug") . "</a>&nbsp;&nbsp;&nbsp;&nbsp;</p>");

  d_DrawFooter();
?>
