<?
  // Anthill
  // $Id: query.php,v 1.63 2003/08/27 22:29:48 vdanen Exp $
  
  include("include.php");

  // set variables
  if (isset($_REQUEST['doit']))       { $doit       = $_REQUEST['doit']; }       else { $doit       = NULL; }
  if (isset($_REQUEST['bug']))        { $bug        = $_REQUEST['bug']; }        else { $bug        = NULL; }
  if (isset($_REQUEST['comment']))    { $comment    = $_REQUEST['comment']; }    else { $comment    = NULL; }
  if (isset($_REQUEST['sbutton']))    { $sbutton    = $_REQUEST['sbutton']; }    else { $sbutton    = NULL; }
  if (isset($_REQUEST['resolve']))    { $resolve    = $_REQUEST['resolve']; }    else { $resolve    = NULL; }
  if (isset($_REQUEST['dup_id']))     { $dup_id     = $_REQUEST['dup_id']; }     else { $dup_id     = NULL; }
  if (isset($_REQUEST['reassign']))   { $reassign   = $_REQUEST['reassign']; }   else { $reassign   = NULL; }
  if (isset($_REQUEST['priv']))       { $priv       = $_REQUEST['priv']; }       else { $priv       = NULL; }
  if (isset($_REQUEST['postassign'])) { $postassign = $_REQUEST['postassign']; } else { $postassign = NULL; }
  if (isset($_REQUEST['comment']))    { $comment    = $_REQUEST['comment']; }    else { $comment    = NULL; }
  if (isset($_REQUEST['url']))        { $url        = $_REQUEST['url']; }        else { $url        = NULL; }
  if (isset($_REQUEST['shortdesc']))  { $shortdesc  = $_REQUEST['shortdesc']; }  else { $shortdesc  = NULL; }
  if (isset($_REQUEST['severity']))   { $severity   = $_REQUEST['severity']; }   else { $severity   = NULL; }
  if (isset($_REQUEST['priority']))   { $priority   = $_REQUEST['priority']; }   else { $priority   = NULL; }
  if (isset($_REQUEST['fixedver']))   { $fixedver   = $_REQUEST['fixedver']; }   else { $fixedver   = NULL; }
  if (isset($_REQUEST['version']))    { $version    = $_REQUEST['version']; }    else { $version    = NULL; }
  if (isset($_REQUEST['component']))  { $component  = $_REQUEST['component']; }  else { $component  = NULL; }
  if (isset($_REQUEST['btnQuery']))   { $btnQuery   = $_REQUEST['btnQuery']; }   else { $btnQuery   = NULL; }
  if (isset($_REQUEST['z']))          { $z          = $_REQUEST['z']; }          else { $z          = "s"; }
  $resolution = NULL;
  $syscomm    = NULL;
  
  d_StartPage(gettext("Query Bug"));
  if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
  d_DrawNav($_USER['uname']);

  d_DrawHeader(gettext("Query Bug"));

  $db->query("SELECT assigned,reporter FROM bugs WHERE bid = '$bug'");
  $db->next_record();
  $bassign  = $db->record['assigned'];
  $reporter = $db->record['reporter'];
  $db->free();

  $db2         = new db_Sql();
  $db2->host   = $_CONF['db_host'];
  $db2->dbase  = $_CONF['db_name'];
  $db2->user   = $_CONF['db_user'];
  $db2->passwd = $_CONF['db_pw'];
  $db2->connect();

  if (isset($doit)) { // make changes to bug
    // make sure that the user is logged in (ie. not expired somehow) prior
    // to making changes to the bug
    if (empty($_USER['uid'])) {
      print("<p>" . gettext("You must be logged in to make changes to a bug.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if ($doit == "add_comment") {
      // add comment to bug
      $query  = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
      $query .= "(NULL,'$bug','" . $_USER['uid'] . "',NULL,0,";
      $query .= "'" . addslashes($comment) . "')";
      $db->query($query);
      $db->free();

      d_doDiff($bug);
    } elseif ($doit == "add_cc") {
      // add cc to list
      $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
      $db->next_record();
      if ($db->record['cc']) {
        $tmpcc = split(", ", $db->record['cc']);
        for ($i=0; $i < count($tmpcc); $i++) {
          if ($tmpcc[$i] == $_USER['email']) {
            $exists = 1;
          }
        }
        // if user doesn't exist, add to cc list
        if ($exists != 1) { // if user doesn't exist, add to list
          $cc = $db->record['cc'] . ", " . $_USER['email'];
        } else { // if user already in list, use old list
          $cc = $db->record['cc'];
        }
      } else {
        $cc = $_USER['email'];
      }
      $db->free();
      $db->query("UPDATE bugs SET cc = '$cc' WHERE bid = '$bug'");
      $db->free();
      $query  = "INSERT INTO bugactivity (aid, bid, user, date, what) ";
      $query .= "VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
      $query .= "NULL, '3')";
      $db->query($query);
      $db->free();
    } elseif ($doit == "rem_cc") {
      // remove cc from list
      $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
      $db->next_record();
      $cc    = split(", ", $db->record['cc']);
      $count = 0;
      for ($i=0; $i < count($cc); $i++) {
        if ($cc[$i] != $_USER['email']) {
          if ($count==0) {
            $newcc = $cc[$i];
            $count++;
          } else {
            $newcc .= ", " . $cc[$i];
            $count++;
          }
        }
      }
      $db->free();
      $db->query("UPDATE bugs SET cc = '$newcc' WHERE bid = '$bug'");
      $db->free();
      $query  = "INSERT INTO bugactivity (aid, bid, user, date, what) ";
      $query .= "VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
      $query .= "NULL, '4')";
      $db->query($query);
      $db->free();
    } elseif ($doit == "admin") {
      switch($sbutton) {
        case "nochange":
          // nothing changes
          break;
        case "accept":
          // change bug to "ASSIGNED"
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat   = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat   = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '2'");
          $db->next_record();
          $nstat   = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '2' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '" . $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "resolve":
          // change bug to "RESOLVED" with resolution status
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '4'");
          $db->next_record();
          $nstat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM resolve_d WHERE id = '$resolve'");
          $db->next_record();
          $res    = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '4' WHERE bid = '$bug'");
          $db->free();
          $db->query("UPDATE bugs SET resolution = '$resolve' WHERE bid = '$bug'");
          $db->free();
          $sdesc  = $nstat['name'] . " (" . $res['name'] . ")";
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '$sdesc')";
          $db->query($query);
          $db->free();
          // If FIXED, allow to set the fixed version
          if ($fixedver != "" && $resolve == 0) {
            $db->query("UPDATE bugs SET fixedver = '$fixedver' WHERE bid = '$bug'");
            $db->free();
          }
          break;
        case "duplicate":
          // changed bug to "RESOLVED" with resolution status DUPLICATE
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat   = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat   = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '4'");
          $db->next_record();
          $nstat   = $db->record;
          $db->free();
          $db->query("SELECT name FROM resolve_d WHERE id = '3'");
          $db->next_record();
          $res     = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '4' WHERE bid = '$bug'");
          $db->free();
          $db->query("UPDATE bugs SET resolution = '3' WHERE bid = '$bug'");
          $db->free();
          $comm1   = "This bug has been marked as a duplicate of bug #<a href=\"query.php?bug=$dup_id\">$dup_id</a>\n";
          $comm2   = "Bug #<a href=\"query.php?bug=$bug\">$bug</a> has been marked as a duplicate of this bug.\n";
          $query   = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
          $query  .= "(NULL,'$dup_id','" . $_USER['uid'] . "',NULL,1,";
          $query  .= "'" . addslashes($comm2) . "')";
          $db->query($query);
          $db->free();
          $query   = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
          $query  .= "(NULL,'$bug','" . $_USER['uid'] . "',NULL,1,";
          $query  .= "'" . addslashes($comm1) . "')";
          $db->query($query);
          $db->free();
          $sdesc   = $nstat['name'] . " (" . $res['name'] . " (#$dup_id))";
          $query   = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query  .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query  .= "NULL, '0', '" . $ostat['name'] . "', '$sdesc')";
          $db->query($query);
          $db->free();
          d_doDiff($dup_id);
          break;
        case "reassign":
          // reassign bug
          // get old owner
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT assigned FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $oassg   = $db->record;
          $db->free();
          $db->query("SELECT email FROM users WHERE uid = '" . $oassg['assigned'] . "'");
          $db->next_record();
          $oass    = $db->record;
          $db->free();
          // now do the updates
          $db->query("SELECT * FROM users WHERE uid = '$reassign'");
          $db->next_record();
          $tmp     = $db->record;
          $db->free();
          $syscomm = sprintf(gettext("This bug has been reassigned to %s."), $tmp['email']) . "\n"; 
          $db->query("UPDATE bugs SET assigned = '$reassign' WHERE bid = '$bug'");
          $db->free();
          $query   = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query  .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query  .= "NULL, '1', '" . $oass['email'] . "', '" . $tmp['email'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "reassigncomp":
          // reassign to component owner
          // get old owner
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT assigned FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $oassg   = $db->record;
          $db->free();
          $db->query("SELECT email FROM users WHERE uid = '" . $oassg['assigned'] . "'");
          $db->next_record();
          $oass    = $db->record;
          $db->free();
          // now do the updates
          $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $tmp     = $db->record;
          $db->free();
          $db->query("SELECT * FROM components WHERE cid = '" . $tmp['component'] . "'");
          $db->next_record();
          $tmp     = $db->record;
          $db->free();
          $db->query("SELECT * FROM users WHERE uid = '" . $tmp['owner'] . "'");
          $db->next_record();
          $tmp     = $db->record;
          $db->free();
          $syscomm = sprintf(gettext("This bug has been reassigned to %s."), $tmp['email']) . "\n"; 
          $db->query("UPDATE bugs SET assigned = '" . $tmp['owner'] . "' WHERE bid = '$bug'");
          $db->free();
          $query   = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query  .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query  .= "NULL, '1', '" . $oass['email'] . "', '" . $tmp['email'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "private":
          // make bug private or public
          // get old state
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT private FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          if ($db->record['private'] == 0) {
            $opr = gettext("PUBLIC");
          } else {
            $opr = gettext("PRIVATE");
          }
          if ($priv == 0) {
            $npr = gettext("PUBLIC");
          } else {
            $npr = gettext("PRIVATE");
          }
          // now do the updates
          $db->query("UPDATE bugs SET private = '$priv' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '2', '$opr', '$npr')";
          $db->query($query);
          $db->free();
          break;
        case "reopen":
          // re-open bug
          // get old status
          if (do_queryaccess($bassign, $reporter) == "0") { term_notreporter(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat   = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat   = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '3'");
          $db->next_record();
          $nstat   = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '3' WHERE bid = '$bug'");
          $db->free();
          $db->query("UPDATE bugs SET resolution = NULL WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '" . $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          // zero out fixed-in-version
          $db->query("UPDATE bugs SET fixedver = '' WHERE bid = '$bug'");
          $db->free();
          $fixedver = "";
          break;
        case "close": 
          // change bug to "CLOSED"
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '6'");
          $db->next_record();
          $nstat  = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '6' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '". $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "passign": 
          // change bug to "VERIFIED" or "UNCONFIRMED"
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '$postassign'");
          $db->next_record();
          $nstat  = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '$postassign' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '". $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "verify": 
          // change bug to "VERIFIED"
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '5'");
          $db->next_record();
          $nstat  = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '5' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '". $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "tovalidate": 
          // change bug to "TOVALIDATE"
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '7'");
          $db->next_record();
          $nstat  = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '7' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '". $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "needswork": 
          // change bug to "NEEDSWORK"
          // get old status
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT status FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '" . $ostat['status'] . "'");
          $db->next_record();
          $ostat  = $db->record;
          $db->free();
          $db->query("SELECT name FROM status_d WHERE id = '8'");
          $db->next_record();
          $nstat  = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET status = '8' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '0', '" . $ostat['name'] . "', '". $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "severity":
          // change severity level
          // get old severity
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT severity FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat = $db->record;
          $db->free();
          $db->query("SELECT name FROM severity_d WHERE id = '" . $ostat['severity'] . "'");
          $db->next_record();
          $ostat = $db->record;
          $db->free();
          $db->query("SELECT name FROM severity_d WHERE id = '$severity'");
          $db->next_record();
          $nstat = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET severity = '$severity' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '7', '" . $ostat['name'] . "', '" . $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        case "priority":
          // change resolution priority
          // get old priority
          if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
          $db->query("SELECT priority FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ostat = $db->record;
          $db->free();
          $db->query("SELECT name FROM priority_d WHERE id = '" . $ostat['priority'] . "'");
          $db->next_record();
          $ostat = $db->record;
          $db->free();
          $db->query("SELECT name FROM priority_d WHERE id = '$priority'");
          $db->next_record();
          $nstat = $db->record;
          $db->free();
          // now do the updates
          $db->query("UPDATE bugs SET priority = '$priority' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '6', '" . $ostat['name'] . "', '" . $nstat['name'] . "')";
          $db->query($query);
          $db->free();
          break;
        default:
          $query = "";
          break;
      }
      if ($comment) {
        $query  = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
        $query .= "(NULL,'$bug','" . $_USER['uid'] . "',NULL,0,";
        $query .= "'" . addslashes($comment) . "')";
        $db->query($query);
        $db->free();
      }
      // system comment for bug re-assigns
      if ($syscomm) {
        $query  = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
        $query .= "(NULL,'$bug','" . $_USER['uid'] . "',NULL,1,";
        $query .= "'$syscomm')";
        $db->query($query);
        $db->free();
      }
      if ($url) {
        if (do_queryaccess($bassign, $reporter) == "0") { term_notreporter(); }
        $db->query("UPDATE bugs SET url = '" . trim(addslashes($url)) . "' WHERE bid = '$bug'");
        $db->free();
      }
      if ($version) { // update the bug's version
        if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
        $db->query("SELECT * FROM versions WHERE vid = '$version'");
        if ($db->num_rows() == 1) {
          $db->query("SELECT version FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $oversion = $db->record;
          $db->free();
          $db->query("SELECT name FROM versions WHERE vid = '" . $oversion['version'] . "'");
          $db->next_record();
          $oversion = $db->record;
          $db->free();
          $db->query("SELECT name FROM versions WHERE vid = '$version'");
          $db->next_record();
          $nversion = $db->record;
          $db->free();
          if ($oversion != $nversion) {
            $db->query("UPDATE bugs SET version = '$version' WHERE bid = '$bug'");
            $db->free();
            $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
            $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
            $query .= "NULL, '9', '" . $oversion['name'] . "', '" . $nversion['name'] . "')";
            $db->query($query);
            $db->free();
          }
        }
      }
      if ($component) { // update the bug's component
        if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
        $db->query("SELECT * FROM components WHERE cid = '$component'");
        if ($db->num_rows() == 1) {
          $db->query("SELECT component FROM bugs WHERE bid = '$bug'");
          $db->next_record();
          $ocomp = $db->record;
          $db->free();
          $db->query("SELECT name FROM components WHERE cid = '" . $ocomp['component'] . "'");
          $db->next_record();
          $ocomp = $db->record;
          $db->free();
          $db->query("SELECT name FROM components WHERE cid = '$component'");
          $db->next_record();
          $ncomp = $db->record;
          $db->free();
          if ($ocomp != $ncomp) {
            $db->query("UPDATE bugs SET component = '$component' WHERE bid = '$bug'");
            $db->free();
            $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
            $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
            $query .= "NULL, '10', '" . $ocomp['name'] . "', '" . $ncomp['name'] . "')";
            $db->query($query);
            $db->free();
          }
        }
      }
      if ($shortdesc) {
        if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
        $ndesc = trim(addslashes($shortdesc));
        $db->query("SELECT shortdesc FROM bugs WHERE bid = '$bug'");
        $db->next_record();
        $odesc  = $db->record;
        $db->free();
        // make sure that the description has actually changed
        if ($ndesc != trim($odesc['shortdesc'])) {
          $db->query("UPDATE bugs SET shortdesc = '$ndesc' WHERE bid = '$bug'");
          $db->free();
          $query  = "INSERT INTO bugactivity (aid, bid, user, date, what, ";
          $query .= "oldval, newval) VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
          $query .= "NULL, '8', '" . $odesc['shortdesc'] . "', '$ndesc')";
          $db->query($query);
          $db->free();
        }
      }
      // If resolved, allow to set the fixed version
      $db->query("SELECT product FROM bugs WHERE bid = '$bug'");
      $db->next_record();
      $bugx = $db->record;
      $db->free();
      if ($fixedver != "" && $bugx['status'] == 0 && $resolve == 0) {
        if (do_queryaccess($bassign, $reporter) != "1") { term_notadmin(); }
        $db->query("UPDATE bugs SET fixedver = '$fixedver' WHERE bid = '$bug'");
        $db->free();
      }

      d_doDiff($bug);
    }
  }

  if (!isset($bug) || isset($btnQuery)) {
    if (isset($btnQuery)) { // we have an advanced query
      $Parameters = z_ParseQueryArguments($HTTP_POST_VARS);
      // $Columns    = z_CheckBoxesArray("show_", $HTTP_POST_VARS);
      $Columns    = z_OrderedListArray("show_",$HTTP_POST_VARS);	
      $SortList   = z_OrderedListArray("sort_",$HTTP_POST_VARS);
      // while (list ($k,$v) = each ($SortList) ) print "\n<br> $k => $v ";
      $Query      = z_ComposeQuery($Parameters,$SortList); 
      // print("\n <font size=-1 color=blue> <b>[$Query]</font></b> <br> "); flush();
      z_PrintResultSet($Columns,$Query);
      print "\n\n<br>";
      d_DrawFooter();
      exit;
    } else { // we have no query, so display our forms
      d_doQuery($_USER['uid'], $z);
      d_DrawFooter();
      exit;
    }
  } else {
    $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
    $db->next_record();
    $bugx = $db->record;
    if ($db->num_rows() == 0) {  // empty bug; non-existant
      print("<p><font color=\"red\">" . gettext("The bug you selected does not exist or is invalid.") . "</font></p>");
      d_doQuery($_USER['uid']);
      d_DrawFooter();
      exit();
    }
    if ($bugx['private'] == 1 && !isset($_USER['uid'])) {
      print("<p><font color=\"red\">" . gettext("The bug you selected is marked private and is not available to unregistered users.") . "</font></p>");
      d_doQuery($_USER['uid']);
      d_DrawFooter();
      exit();
    }
    $db->free();

    // get product info
    $db->query("SELECT * FROM products WHERE pid = '" . $bugx['product'] . "'");
    $db->next_record();
    $product = $db->record['name'];
    $db->free();

    // get version info
    $db->query("SELECT * FROM versions WHERE vid = '" . $bugx['version'] . "'");
    $db->next_record();
    $version = $db->record['name'];
    $db->free();

    // get component info
    $db->query("SELECT * FROM components WHERE cid = '" . $bugx['component'] . "'");
    $db->next_record();
    $component = $db->record['name'];
    $db->free();

    // get user info
    $db->query("SELECT * FROM users WHERE uid = '" . $bugx['reporter'] . "'");
    $db->next_record(); 
    $email = $db->record['email'];
    if ($db->record['gpg'] != "") {
      $gpg = " [ <a href=\"" . $_CONF['webroot'] . $db->record['gpg'] . "\">gpg</a> ] ";
    } else {
      $gpg = "";
    }
    $db->free();

    // get status info
    $db->query("SELECT * FROM status_d WHERE id = '" . $bugx['status'] . "'");
    $db->next_record();
    $status = $db->record['name'];
    $statid = $db->record['id'];
    $db->free();

    // get severity info
    $db->query("SELECT * FROM severity_d WHERE id = '" . $bugx['severity'] . "'");
    $db->next_record();
    $severity_id = $db->record['id'];
    $severity    = $db->record['name'];
    $db->free();

    // get resolution info
    if ($bugx['resolution'] != "") {
      $db->query("SELECT * FROM resolve_d WHERE id = '" . $bugx['resolution'] . "'");
      $db->next_record();
      $resolution = $db->record['name'];
      $db->free();
    }

    // get priority info
    $db->query("SELECT * FROM priority_d WHERE id = '" . $bugx['priority'] . "'");
    $db->next_record();
    $priority_id = $db->record['id'];
    $priority    = $db->record['name'];
    $db->free();

    // get fixed-in-version info (if it exists)
    if ($bugx['fixedver'] != "") {
      $fixinver = $bugx['fixedver'];
    } else {
      $fixinver = NULL;
    }
?>

  <table border="0" cellpadding="0" cellspacing="2" width="100%">
    <tr>
      <td width="20%" align="center" bgcolor=<? print($config['barcol1']); ?>>
        <b><? print(gettext("Product") . " - " . gettext("Version")); ?></b>
      </td>
      <td width="20%" align="center" bgcolor=<? print($config['barcol1']); ?>>
        <b><? print(gettext("Component")); ?></b>
      </td>
      <td width="20%" align="center" bgcolor=<? print($config['barcol1']); ?>>
        <b><? print(gettext("Status")); ?></b>
      </td>
      <td width="40%" bgcolor=<? print($config['barcol1']); ?>>
        <b><? print(gettext("Short Summary")); ?></b>
      </td>
    </tr>
    <tr>
      <td width="20%" align="center" bgcolor=<? print($config['barcol2']); ?>>
        <? print(sprintf("%s - %s",$product,$version)); ?>
      </td>
      <td width="20%" align="center" bgcolor=<? print($config['barcol2']); ?>>
        <? print($component); ?>
      </td>
      <td width="20%" align="center" bgcolor=<? print($config['barcol2']); ?>>
        <? print($status); ?>
      </td>
      <td width="40%" bgcolor=<? print($config['barcol2']); ?>>
        <? print(htmlspecialchars(stripslashes($bugx['shortdesc']))); ?>
      </td>
    </tr>
    <tr>
      <td colspan="4" width="100%">
        <br />
      </td>
    </tr>
    <tr>
      <td width="100%" colspan="4" bgcolor=<? print($config['barcol1']); ?>>
        <b>
        <? $d = d_getTime($bugx['creation']);
           print(sprintf(gettext("Opened by <a href=\"mailto:%s\">%s</a> %s on %s"), $email, $email, $gpg, $d)); 
        ?>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b><? print(gettext("Long Description")); ?></b>
      </td>
    </tr>
    <tr>
      <td colspan="4" width="100%">
        <? $db->query("SELECT * FROM bugdesc WHERE bid = '" . $bugx['bid'] . "' ORDER BY date");
           $count = 0;
           while ($db->next_record()) {
             if ($count > 0) {
               $cdate  = d_getTime($db->record['date']);
               $db2->query("SELECT * FROM users WHERE uid = '" . $db->record['user'] . "'");
               $db2->next_record();
               $cemail = $db2->record['email'];
               if ($db2->record['gpg'] != "") {
                 $cgpg = " [ <a href=\"" . $_CONF['webroot'] . $db2->record['gpg'] . "\">gpg</a> ] ";
               } else {
                 $cgpg = "";
               }
               $db2->free();
               print("<br />------ ");
               print(sprintf(gettext("Additional comments from <a href=\"mailto:%s\">%s</a> %s on %s"), $cemail, $cemail, $cgpg, $cdate));
               print(" ------<br />");
             }
             if ($db->record['system'] == 1) {
               print(stripslashes($db->record['description']));
             } else {
               // sanitize things, we only addslashes when saving to the
               // database so now we have to make things safe
               $desc = nl2br(d_TransURL(htmlspecialchars(stripslashes($db->record['description'])),1));
               print($desc);
             }
             print("<br />");
             $count++;
           }
           $db->free();
        ?>
      </td>
    </tr>
  </table>

  <br />

  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
      <td colspan="4" width="100%" bgcolor=<? print($config['barcol1']); ?>>
        <b><? print(gettext("Additional Information")); ?></b>
      </td>
    </tr>
    <tr>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Bug")); ?>#:</b>
      </td>
      <td width="30%" valign="top">
        <? print($bug); ?>
      </td>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Product")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? print($product); ?>
      </td>
    </tr>
    <tr>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Status")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? print($status); ?>
      </td>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Component")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? print($component); ?>
      </td>
    </tr>
    <tr>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Resolution")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? print($resolution);
           if(isset($fixinver)) {
             print(" " . sprintf(gettext("(in version %s)"),$fixinver));
           }
        ?>
      </td>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Priority")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? print($priority); ?>
      </td>
    </tr>
    <tr>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Assigned To")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? $db->query("SELECT * FROM users WHERE uid = '" . $bugx['assigned'] . "'");
           $db->next_record();
           if ($db->record['gpg'] != "") {
             $mgpg = " [ <a href=\"" . $_CONF['webroot'] . $db->record['gpg'] . "\">gpg</a> ] ";
           } else {
             $mgpg = "";
           }
           print(sprintf("<a href=\"mailto:%s\">%s</a> %s", $db->record['email'], $db->record['email'], $mgpg)); 
           $db->free();
        ?>
      </td>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Severity")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? print($severity); ?>
      </td>
    </tr>
    <tr>
      <td width="20%" align="right" valign="top">
         <b><? print(gettext("Email CC")); ?>:</b>
      </td>
      <td width="30%" valign="top">
         <? print($bugx['cc']); ?>
      </td>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Reporter")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? print(sprintf("<a href=\"mailto:%s\">%s</a> %s", $email, $email, $gpg)); ?>
      </td>
    </tr>
    <tr>
      <td width="20%" align="right" valign="top">
         <b>URL:</b>
      </td>
      <td width="30%" valign="top">
         <a href="<? print(trim(stripslashes($bugx['url']))); ?>"><? print(stripslashes($bugx['url'])); ?></a>
      </td>
      <td width="20%" align="right" valign="top">
        <b><? print(gettext("Type")); ?>:</b>
      </td>
      <td width="30%" valign="top">
        <? if ($bugx['private'] == 0) {
             print(gettext("PUBLIC"));
           } else {
             print(gettext("PRIVATE"));
           }
        ?>
      </td>
    </tr>
    <tr>
      <td width="20%" align="right" valign="top">
        <b>Attachments:</b>
      </td>
      <td width="80%" valign="top" colspan="3">
        <? $db->query("SELECT * FROM attachidx WHERE bid = $bug ORDER BY date ASC");
           while ($db->next_record()) {
             $date = d_getTime($db->record['date']);
             print(sprintf("id %s: <a href=\"showattachment.php?id=%s\">%s</a> - %s<br />", $db->record['atid'], $db->record['atid'], $date, $db->record['filename']));
           }
           $db->free();
        ?>
        <a href="createattachment.php?bug=<? print($bug); ?>">Create a new attachment</a> (proposed patch, testcase, etc.)
      </td>
    </tr>
  </table>

  <br />
  <center>
  <b><p>[ <a href="activity.php?bug=<? print($bug); ?>"><? print(gettext("View Activity Log")); ?></a> ] </p></b>
  </center>
  <br />

<? if (isset($_USER['uid'])) { // only display form to logged in users ?>
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
      <td width="100%" align="center">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr>
            <td align="center">
              <form method="post" action="query.php">
              <input type="submit" name="add_cc" value="<? print(gettext("Add Me to CC List")); ?>">
              <input type="hidden" name="bug" value="<? print($bug); ?>">
              <input type="hidden" name="doit" value="add_cc">
              </form>
            </td>
            <td align="center">
              <form method="post" action="query.php">
              <input type="submit" name="rem_cc" value="<? print(gettext("Remove Me from CC List")); ?>">
              <input type="hidden" name="bug" value="<? print($bug); ?>">
              <input type="hidden" name="doit" value="rem_cc">
              </form>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td width="100%" bgcolor=<? print($config['barcol1']); ?>>
        <b><? print(gettext("Additional comments from")); ?></b>
      </td>
    </tr>
    <tr>
      <td width="100%" align="center">
        <form method="post" action="query.php">
        <textarea name="comment" cols="76" rows="10" wrap="hard"></textarea><br />
        <span class="tiny"><? print(gettext("NOTE: Please use plaintext only; HTML will not be parsed.")); ?></span>
      </td>
    </tr>
<?  // begin displaying the stuff to owner, admin, and/or reporter
    if (do_queryaccess($bassign, $reporter) != "0") {
      if (do_queryaccess($bassign, $reporter) == "2") {
        if ($bugx['status'] == "4" || $bugx['status'] == "6") { // let reporter re-open bug
      ?>
    <tr>
      <td width="100%">
        <br />
        <? print(gettext("You may choose to re-open this bug if you do not feel it was resolved properly:")); ?><br />
        <input type="radio" name="sbutton" value="reopen">
        <? print(gettext("Re-open bug")); ?>
      </td>
    </tr>
      <? }
       }
?>
    <tr>
      <td width="100%">
        <br />
        <? print(gettext("Change URL: (include prefix)")); ?> <input name="url" size="76" maxlength="128" value="<? print(trim(stripslashes($bugx['url']))); ?>">
      </td>
    </tr>
<?  }
    if (do_queryaccess($bassign, $reporter) == "1") {
?>
    <tr>
      <td width="100%">
        <br />
        <? print(gettext("Change description:")); ?> <input name="shortdesc" size="76" maxlength="128" value="<? print(trim(stripslashes($bugx['shortdesc']))); ?>">
      </td>
    </tr>
    <tr>
      <td width="100%">
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
          <tr>
            <td width="50%" valign="top">
              <? $db->query("SELECT * FROM versions WHERE (product = '" . $bugx['product'] . "') AND (deleted = '0') ORDER BY name ASC");
                 if ($db->num_rows() > 1) { ?>
                   <? print(gettext("Change product version:")); ?> 
                   <select name="version">
                   <? while ($db->next_record()) {
                        if ($db->record['vid'] == $bugx['version']) {
                          $selected = "SELECTED";
                        } else {
                          $selected = "";
                        }
                        print(sprintf("<option value=\"%s\" %s>%s</option>\n",$db->record['vid'],$selected,$db->record['name']));
                        $i++;
                      }
                      $db->free();
                   ?>
                   </select>
              <? } // if version ?>&nbsp;
            </td>
            <td width="25%" align="right" valign="top">
              <? if ($config['allowcompchange'] == 1) {
                   $db->query("SELECT * FROM components WHERE (product = '" . $bugx['product'] . "') AND (deleted = '0') ORDER BY name ASC");
                   if ($db->num_rows() > 1) {
                     print(gettext("Change product component:")); 
                   }
                 } else {
                   print("&nbsp;");
                 }
              ?>
            </td>
            <td width="25%" valign="top">
              <? if ($config['allowcompchange'] == 1) {
                   $db->query("SELECT * FROM components WHERE (product = '" . $bugx['product'] . "') AND (deleted = '0') ORDER BY name ASC");
                   if ($db->num_rows() > 1) { ?>
              <select name="component" size="5">
              <? while ($db->next_record()) {
                   if ($db->record['cid'] == $bugx['component']) {
                     $selected = "SELECTED";
                   } else {
                     $selected = "";
                   }
                   print(sprintf("<option value=\"%s\" %s>%s</option>\n",$db->record['cid'],$selected,$db->record['name']));
                   $i++;
                 }
                 $db->free();
              ?>
              </select>
              <? } //if allowcompchange
                 } // if component ?>&nbsp;
            </td>
          </tr>
        </table>
      </td>
    </tr>
<?  }
    if (do_queryaccess($bassign, $reporter) == "1") {
?>
  </table>

  <br />

  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
      <td width="100%" bgcolor=<? print($config['barcol1']); ?>>
        <b><? print(gettext("Change State or Resolution")); ?></b> (<? print(gettext("only by owner or privileged member")); ?>)
      </td>
    </tr>
    <tr>
      <td width="100%">
        <input type="radio" name="sbutton" value="nochange" CHECKED>
        <? print(sprintf(gettext("Leave as <b>%s</b>"), $status)); ?><br />

        <? if ($statid == "1") { // if status "NEW" ?>
          <input type="radio" name="sbutton" value="accept">
          <?  $db->query("SELECT * FROM status_d WHERE id = '2'");
              $db->next_record();
              print(sprintf(gettext("Accept problem (change status to <b>%s</b>)"), $db->record['name']));
              $db->free();
          ?><br />
        <? } ?>

        <? if ($statid == "2") { // if status "ASSIGNED" ?>
          <input type="radio" name="sbutton" value="passign">
          <? print(gettext("Work on bug, changing status to")); ?>
          <select name="postassign">
          <? $db->query("SELECT * FROM status_d WHERE id = '5' OR id = '0'");
             while ($db->next_record()) {
               print(sprintf("<option value=\"%s\">%s</option>\n",$db->record['id'],$db->record['name']));
             }
             $db->free();
          ?></select><br />
        <? } ?>

        <? if ($statid == "0") { // if status "UNCONFIRMED" ?>
          <input type="radio" name="sbutton" value="verify">
          <? print(gettext("Verify this unconfirmed bug")); ?><br />
        <? } ?>
        
        <? if ($statid == "5" || $statid == "8" ) { // if status "VERIFIED" or "NEEDSWORK" ?>
          <input type="radio" name="sbutton" value="tovalidate">
          <? print(gettext("Solution requires testing/validation from QA")); ?><br />
        <? } ?>
        
        <? if ($statid == "5" || $statid == "7") { // if status "VERIFIED" or "TOVALIDATE" ?>
          <input type="radio" name="sbutton" value="needswork">
          <? print(gettext("Bug requires more work or fix not appropriate")); ?><br />
        <? } ?>

     <? if ($statid != "4" && $statid != "6") { // if not status "RESOLVED" ?>
        <input type="radio" name="sbutton" value="priority">
        <? print(gettext("Change resolution priority to")); ?>
        <select name="priority">
        <? $db->query("SELECT * FROM priority_d");
           while($db->next_record()) {
             if ($db->record['id'] == $priority_id) {
               $def = "SELECTED";
             } else {
               $def = "";
             }
             print(sprintf("<option value=\"%s\" %s>%s</option>\n",$db->record['id'],$def,$db->record['name']));
           }
        ?></select><br />
        <input type="radio" name="sbutton" value="severity">
        <? print(gettext("Change bug severity to")); ?>
        <select name="severity">
        <? $db->query("SELECT * FROM severity_d");
           while($db->next_record()) {
             if ($db->record['id'] == $severity_id) {
               $def = "SELECTED";
             } else {
               $def = "";
             }
             print(sprintf("<option value=\"%s\" %s>%s</option>\n",$db->record['id'],$def,$db->record['name']));
           }
        ?></select><br />
        <input type="radio" name="sbutton" value="resolve">
        <? print(gettext("Resolve bug, changing resolution to")); ?>
        <select name="resolve">
        <?  $db->query("SELECT * FROM resolve_d");
            while ($db->next_record()) {
              if ($db->record['id'] != 3) {  // don't print "DUPLICATE"
                print(sprintf("<option value=\"%s\">%s</option>\n",$db->record['id'],$db->record['name']));
              }
            }
            $db->free();
        ?>
        </select><br />
        <? print(gettext("If FIXED, you may also select a version:")); ?>
        <input type="text" name="fixedver" size="8" maxsize="8"><br />

        <input type="radio" name="sbutton" value="duplicate">
        <? print(gettext("Resolve bug, make it a duplicate of problem")); ?> #
        <input type="text" name="dup_id" size="6" maxsize="6"><br />

        <input type="radio" name="sbutton" value="close">
        <? print(gettext("Close bug with no resolution")); ?><br />

        <input type="radio" name="sbutton" value="reassign">
        <? print(gettext("Reassign problem to")); ?>
        <select name="reassign">
        <?  $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0')");
            while ($db->next_record()) {
              print(sprintf("<option value=\"%s\">%s</option>\n",$db->record['uid'],$db->record['email']));
            }
            $db->free();
        ?>
        </select><br />

        <input type="radio" name="sbutton" value="reassigncomp">
        <? print(gettext("Reassign problem to owner of selected component")); ?><br />

        <input type="radio" name="sbutton" value="private">
        <? if ($bugx['private'] == 0) {
             print(gettext("Mark this bug private"));
             print("<input type=\"hidden\" name=\"priv\" value=\"1\">");
           } else {
             print(gettext("Mark this bug public"));
             print("<input type=\"hidden\" name=\"priv\" value=\"0\">");
           }
        ?>
     <? } else { // if status "RESOLVED" ?>
        <input type="radio" name="sbutton" value="reopen">
        <? print(gettext("Re-open bug")); ?><br />
        <? print(gettext("If FIXED, you may also select a version:")); ?>
        <input type="text" name="fixedver" size="8" maxsize="8" value="<? print($fixinver); ?>"><br />
     <? } ?>
      </td>
    </tr>
    <tr>
      <td width="100%" valign="center">
        <input type="submit" value="<? print(gettext("Save Changes")); ?>">
        <input type="reset" value="<? print(gettext("Reset")); ?>">
        <input type="hidden" name="bug" value="<? print($bug); ?>">
        <input type="hidden" name="doit" value="admin">
        </form>
      </td>
    </tr>
  </table>

<?
    } else {
?>

    <tr>
      <td width="100%" align="center">
        <input type="submit" name="add_comment" value="<? print(gettext("Add Comment")); ?>">
        <input type="hidden" name="doit" value="add_comment">
        <input type="hidden" name="bug" value="<? print($bug); ?>">
        <? if (do_queryaccess($bassign, $reporter) != "0") { // we need the doit button to make url/etc. changes ?>
        <input type="hidden" name="doit" value="admin">
        <? } ?>
        </form>
      </td>
    </tr>
  </table>

<?
      }
    } else { 
      print("</table>");
    } // end isset($_USER['uid'])

  } // end isset($bug)

  d_DrawFooter();
?>
