<?
  // Anthill
  // $Id: reports.php,v 1.22 2003/09/10 03:00:51 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['pid'])) { $pid = $_REQUEST['pid']; } else { $pid = NULL; }

  d_StartPage(gettext("Bug Reports"));
  if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) { exit; }
  d_DrawNav($_USER['uname']);
  
  $db2         = new db_Sql();
  $db2->host   = $_CONF['db_host'];
  $db2->dbase  = $_CONF['db_name'];
  $db2->user   = $_CONF['db_user'];
  $db2->passwd = $_CONF['db_pw'];
  $db2->connect();

  $db->query("SELECT * FROM products");
  if ($db->num_rows() == 1) {
    $db->next_record();
    $pid = $db->record['pid'];
  }
  $db->free();

  if (!isset($pid)) {
    d_DrawHeader(gettext("Select Product To Report On"));
    ?>
    <form method="post" action="reports.php">
    <table border="0" cellpadding="0" cellspacing="0" width="40%" align="center">
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Select Product")); ?>:
        </td>
        <td width="50%">
          <select name="pid">
          <? $db->query("SELECT * FROM products WHERE deleted = '0' ORDER BY name");
             while ($db->next_record()) {
               print(sprintf("<option value=\"%s\">%s</option>\n",$db->record['pid'],$db->record['name']));
             }
             $db->free();
          ?>
          <option value="all">All Products</option>
          </select>
        </td>
      </tr>
      <tr>
        <td width="50%">
          &nbsp;
        </td>
        <td width="50%">
          <input type="submit" value="<? print(gettext("Continue")); ?>">
        </td>
      </tr>
    </table>
    </form>
    <?
    d_DrawFooter();
    exit;
  }

  d_DrawHeader(gettext("Bug Reports"));

  $date = date(sprintf("%s %s", $_CONF['datefmt'], $_CONF['timefmt']));
  if ($pid != "all") {
    $db->query("SELECT * FROM products WHERE pid = '$pid'");
    $db->next_record();
    $prod  = $db->record;
    $qtag  = " AND product = '$pid'";
    $qtag2 = " WHERE product = '$pid'";
    $qtag3 = " AND (bugs.product = '$pid')";
  } else {
    $prod['name'] = "All Products";
    $qtag  = "";
    $qtag2 = "";
    $qtag3 = "";
  }

  print("<p><b>" . sprintf(gettext("Bug Report for %s"), $prod['name']) . "</b></p>");
  print("<p>$date</p>");
  print("<p><b>" . gettext("Summary") . "</b></p>");
?>

  <table border="0" cellpadding="0" cellspacing="0" width="30%">
    <tr>
      <td width="55%">
        <? print(gettext("New Bugs This Week")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $sunday = date("YmdHis",mktime(0,0,0,date("m"),date("d")-date("w",mktime(0,0,0,date("m"),date("d"),date("Y"))),date("Y")));
           $db->query(sprintf("SELECT * FROM bugs WHERE creation >= '$sunday' %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Resolved Bugs This Week")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $sunday = date("YmdHis",mktime(0,0,0,date("m"),date("d")-date("w",mktime(0,0,0,date("m"),date("d"),date("Y"))),date("Y")));
           $db->query(sprintf("SELECT * FROM bugs WHERE (modified >= '$sunday') AND (status = '4') %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("New Bugs In Last 30 Days")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $thirty = date("YmdHis", mktime(0,0,0,date("m")-1,date("d"),date("Y")));
           $db->query(sprintf("SELECT * FROM bugs WHERE creation >= '$thirty' %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Resolved Bugs In Last 30 Days")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $thirty = date("YmdHis", mktime(0,0,0,date("m")-1,date("d"),date("Y")));
           $db->query(sprintf("SELECT * FROM bugs WHERE (modified >= '$thirty') AND (status = '4') %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Bugs Marked New")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $db->query(sprintf("SELECT * FROM bugs WHERE status = '1' %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Bugs Marked Assigned")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $db->query(sprintf("SELECT * FROM bugs WHERE status = '2' %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Bugs Marked Verified")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $db->query(sprintf("SELECT * FROM bugs WHERE status = '5' %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Bugs Marked Unconfirmed")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $db->query(sprintf("SELECT * FROM bugs WHERE status = '0' %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Bugs Marked Reopened")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $db->query(sprintf("SELECT * FROM bugs WHERE status = '3' %s", $qtag));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="55%">
        <? print(gettext("Total Bugs")); ?>:
      </td>
      <td width="10%">&nbsp;</td>
      <td width="35%">
        <? $db->query(sprintf("SELECT * FROM bugs %s", $qtag2));
           print($db->num_rows());
           $db->free();
        ?>
      </td>
    </tr>
  </table>

  <br /><p><b><? print(gettext("Open Bug Count by Owner")); ?></b></p>
  <table border="0" cellpadding="0" cellspacing="0" width="80%">
    <tr>
      <td width="20%">
        <u><? print(gettext("Owner")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("New")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Assigned")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Verified")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Unconfirmed")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Reopened")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("To Validate")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Needs Work")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Total")); ?></u>
      </td>
    </tr>
    <? $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '1' %s", $qtag));
       $new = $db->num_rows();
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '5' %s", $qtag));
       $ver = $db->num_rows();
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '2' %s", $qtag));
       $ass = $db->num_rows();
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '0' %s", $qtag));
       $unc = $db->num_rows();
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '3' %s", $qtag));
       $rop = $db->num_rows();
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '7' %s", $qtag));
       $val = $db->num_rows();
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '8' %s", $qtag));
       $nwo = $db->num_rows();
       $db->free();
       
       $tot = $new + $ver + $ass + $rop + $val + $nwo;
       
       if ($tot > 0) {
    ?>
    <tr>
      <td width="30%">
         Unassigned
      </td>
      <td width="10%" align="center">
        <? print($new); ?>
      </td>
      <td width="10%" align="center">
        <? print($ass); ?>
      </td>
      <td width="10%" align="center">
        <? print($ver); ?>
      </td>
      <td width="10%" align="center">
        <? print($unc); ?>
      </td>
      <td width="10%" align="center">
        <? print($rop); ?>
      </td>
      <td width="10%" align="center">
        <? print($val); ?>
      </td>
      <td width="10%" align="center">
        <? print($nwo); ?>
      </td>
      <td width="10%" align="center">
        <? print($tot); ?>
      </td>
    </tr>
    <? }
       $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY uname");
       while ($db->next_record()) {
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '1' %s", $qtag));
         $new   = $db2->num_rows();
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '5' %s", $qtag));
         $ver   = $db2->num_rows();
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '2' %s", $qtag));
         $ass   = $db2->num_rows();
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '0' %s", $qtag));
         $unc   = $db2->num_rows();
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '3' %s", $qtag));
         $rop   = $db2->num_rows();
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '7' %s", $qtag));
         $val   = $db2->num_rows();
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '8' %s", $qtag));
         $nwo   = $db2->num_rows();
         $db2->free();
         
         $tot = $new + $ver + $ass + $rop + $val + $nwo;
         
         if ($tot > 0) {
    ?>
    <tr>
      <td width="30%">
        <? print($db->record['email']); ?>
      </td>
      <td width="10%" align="center">
        <? print($new); ?>
      </td>
      <td width="10%" align="center">
        <? print($ass); ?>
      </td>
      <td width="10%" align="center">
        <? print($ver); ?>
      </td>
      <td width="10%" align="center">
        <? print($unc); ?>
      </td>
      <td width="10%" align="center">
        <? print($rop); ?>
      </td>
      <td width="10%" align="center">
        <? print($val); ?>
      </td>
      <td width="10%" align="center">
        <? print($nwo); ?>
      </td>
      <td width="10%" align="center">
        <? print($tot); ?>
      </td>
    </tr>
    <?   }
       } ?>
    <tr>
      <td colspan="7">
        <br /><p><b><? print(gettext("Bug Count by Reporter")); ?></b><br />&nbsp;</p>
      </td>
    </tr>
    <tr>
      <td width="30%">
        <u><? print(gettext("Owner")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Reported")); ?></u>
      </td>
      <td width="30%" colspan="3" align="center">
        <u><? print(gettext("Last Reported")); ?></u>
      </td>
      <td colspan="2">
        &nbsp;
      </td>
    </tr>
    <? $db->query(sprintf("SELECT * FROM bugs WHERE reporter = '0' %s ORDER BY creation DESC", $qtag));
       $rep         = $db->num_rows();
       $db->next_record();
       $lastrepdate = d_getTime($db->record['creation']);
       $db->free();
       if ($rep > 0) {
    ?>
    <tr>
      <td width="30%">
         Unassigned
      </td>
      <td width="10%" align="center">
        <? print($rep); ?>
      </td>
      <td width="30%" colspan="3" align="center">
        <? print($lastrepdate); ?>
      </td>
      <td colspan="2">
        &nbsp;
      </td>
    </tr>
    <? }
       $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY uname");
       while ($db->next_record()) {
         $db2->query(sprintf("SELECT * FROM bugs WHERE reporter = '" . $db->record['uid'] . "' %s ORDER BY creation DESC", $qtag));
         $rep         = $db2->num_rows();
         $db2->next_record();
         $lastrepdate = d_getTime($db2->record['creation']);
         $db2->free();
         if ($rep > 0) {
    ?>
    <tr>
      <td width="30%">
        <? print($db->record['email']); ?>
      </td>
      <td width="10%" align="center">
        <? print($rep); ?>
      </td>
      <td width="30%" colspan="3" align="center">
        <? print($lastrepdate); ?>
      </td>
      <td colspan="3">
        &nbsp;
      </td>
    </tr>
    <?   }
       } ?>
      <td colspan="7">
        <br /><p><b><? print(gettext("Summary of Participant Comments")); ?></b><br />&nbsp;</p>
      </td>
    </tr>
    <tr>
      <td width="30%">
        <u><? print(gettext("Participant")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("In Last 30")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Total")); ?></u>
      </td>
      <td width="30%" colspan="3" align="center">
        <u><? print(gettext("Last Comment")); ?></u>
      </td>
      <td>
        &nbsp;
      </td>
    </tr>
    <? $db->query("SELECT * FROM users WHERE deleted = '0' ORDER BY uname");
       while ($db->next_record()) {
         // this is my first-ever JOIN so be nice
         $db2->query(sprintf("SELECT bugdesc.date FROM bugdesc LEFT JOIN bugs ON bugdesc.bid=bugs.bid WHERE (bugdesc.user = '" . $db->record['uid'] . "') AND (bugdesc.system = '0') %s ORDER BY bugdesc.date DESC", $qtag3));
         // $db2->query("SELECT * FROM bugdesc WHERE (user = '" . $db->record['uid'] . "') AND (system = '0') ORDER BY date DESC");
         $rep         = $db2->num_rows();
         $db2->next_record();
         $lastrepdate = d_getTime($db2->record['date']);
         $db2->free();
         if ($rep > 0) {
           $thirty = date("YmdHis", mktime(0,0,0,date("m")-1,date("d"),date("Y")));
           $db2->query(sprintf("SELECT bugdesc.date FROM bugdesc LEFT JOIN bugs ON bugdesc.bid=bugs.bid WHERE (bugdesc.user = '" . $db->record['uid'] . "') AND (bugdesc.system = '0') AND (bugdesc.date > '$thirty') %s ORDER BY bugdesc.date DESC", $qtag3));
           // $db2->query("SELECT * FROM bugdesc WHERE (user = '" . $db->record['uid'] . "') AND (date > '$thirty') AND (system = '0')");
           $last      = $db2->num_rows();
           $db2->free();
    ?>
    <tr>
      <td width="30%">
        <? print($db->record['email']); ?>
      </td>
      <td width="10%" align="center">
        <? print($last); ?>
      </td>
      <td width="10%" align="center">
        <? print($rep); ?>
      </td>
      <td width="30%" colspan="3" align="center">
        <? print($lastrepdate); ?>
      </td>
      <td>
        &nbsp;
      </td>
    </tr>
    <?   }
       } ?>
  </table>

  <p><b><? print(gettext("Individual Open Bugs by Owner")); ?></b></p>
  <table border="1" cellpadding="0" cellspacing="0" width="80%">
    <tr>
      <td width="30%">
        <? print(gettext("Owner")); ?>
      </td>
      <td width="15%" align="center">
        <? print(gettext("New")); ?>
      </td>
      <td width="15%" align="center">
        <? print(gettext("Assigned")); ?>
      </td>
      <td width="15%" align="center">
        <? print(gettext("Verified")); ?>
      </td>
      <td width="10%" align="center">
        <? print(gettext("Unconfirmed")); ?>
      </td>
      <td width="15%" align="center">
        <? print(gettext("Reopened")); ?>
      </td>
    </tr>
    <? $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '1' %s", $qtag));
       $new     = $db->num_rows();
       $newlist = "";
       while ($db->next_record()) {
         $newlist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ", $newlist, $db->record['bid'], $db->record['bid']);
       }
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '2' %s", $qtag));
       $assigned = $db->num_rows();
       $asslist  = "";
       while ($db->next_record()) {
         $asslist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ", $asslist, $db->record['bid'], $db->record['bid']);
       }
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '5' %s", $qtag));
       $verified = $db->num_rows();
       $verlist  = "";
       while ($db->next_record()) {
         $verlist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ", $verlist, $db->record['bid'], $db->record['bid']);
       }
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '0' %s", $qtag));
       $unconfirmed = $db->num_rows();
       $unconflist  = "";
       while ($db->next_record()) {
         $unconflist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ", $unconflist, $db->record['bid'], $db->record['bid']);
       }
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '3' %s", $qtag));
       while ($db->next_record()) {
       $reopened = $db->num_rows();
       $reoplist = "";
         $reoplist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ", $reoplist, $db->record['bid'], $db->record['bid']);
       }
       $db->free();
       
       $total = $new + $assigned + $verified + $unconfirmed + $reopened;
       if ($total > 0) {
    ?>
    <tr>
      <td width="30%" valign="top">
         Unassigned
      </td>
      <td width="15%" align="center" valign="top">
        <? print($newlist); ?>&nbsp;
      </td>
      <td width="15%" align="center" valign="top">
        <? print($asslist); ?>&nbsp;
      </td>
      <td width="15%" align="center" valign="top">
        <? print($verlist); ?>&nbsp;
      </td>
      <td width="10%" align="center" valign="top">
        <? print($unconflist); ?>&nbsp;
      </td>
      <td width="15%" align="center" valign="top">
        <? print($reoplist); ?>&nbsp;
      </td>
    </tr>
    <? }
       $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY uname");
       while ($db->next_record()) {
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '1' %s", $qtag));
         $new     = $db2->num_rows();
         $newlist = "";
         while ($db2->next_record()) {
           $newlist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ",$newlist, $db2->record['bid'], $db2->record['bid']);
         }
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '2' %s", $qtag));
         $assigned = $db2->num_rows();
         $asslist  = "";
         while ($db2->next_record()) {
           $asslist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ",$asslist, $db2->record['bid'], $db2->record['bid']);
         }
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '5' %s", $qtag));
         $verified = $db2->num_rows();
         $verlist  = "";
         while ($db2->next_record()) {
           $verlist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ",$verlist, $db2->record['bid'], $db2->record['bid']);
         }
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '0' %s", $qtag));
         $unconfirmed = $db2->num_rows();
         $unconlist   = "";
         while ($db2->next_record()) {
           $unconlist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ",$unconlist, $db2->record['bid'], $db2->record['bid']);
         }
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '3' %s", $qtag));
         $reopened = $db2->num_rows();
         $reoplist = "";
         while ($db2->next_record()) {
           $reoplist = sprintf("%s <a href=\"query.php?bug=%s\">%s</a> ",$reoplist, $db2->record['bid'], $db2->record['bid']);
         }
         $db2->free();
         $total = $new + $assigned + $verified + $unconfirmed + $reopened;
         if ($total > 0) {
    ?>
    <tr>
      <td width="30%" valign="top">
        <? print($db->record['email']); ?>
      </td>
      <td width="15%" align="center" valign="top">
        <? print($newlist); ?>&nbsp;
      </td>
      <td width="15%" align="center" valign="top">
        <? print($asslist); ?>&nbsp;
      </td>
      <td width="15%" align="center" valign="top">
        <? print($verlist); ?>&nbsp;
      </td>
      <td width="10%" align="center" valign="top">
        <? print($unconlist); ?>&nbsp;
      </td>
      <td width="15%" align="center" valign="top">
        <? print($reoplist); ?>&nbsp;
      </td>
    </tr>
    <?   }
       }
       $db->free(); 
    ?>
  </table>
  
  <br /><p><b><? print(gettext("Closed Bug Count by Owner")); ?></b></p>
  <table border="0" cellpadding="0" cellspacing="0" width="50%">
    <tr>
      <td width="30%">
        <u><? print(gettext("Owner")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Resolved")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Closed")); ?></u>
      </td>
      <td width="10%" align="center">
        <u><? print(gettext("Total")); ?></u>
      </td>
    </tr>
    <? $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '4' %s", $qtag));
       $res = $db->num_rows();
       $db->free();
       $db->query(sprintf("SELECT * FROM bugs WHERE assigned = '0' AND status = '6' %s", $qtag));
       $clo = $db->num_rows();
       $db->free();
       
       $tot = $res + $clo;
       
       if ($tot > 0) {
    ?>
    <tr>
      <td width="30%">
         Unassigned
      </td>
      <td width="10%" align="center">
        <? print($res); ?>
      </td>
      <td width="10%" align="center">
        <? print($clo); ?>
      </td>
      <td width="10%" align="center">
        <? print($tot); ?>
      </td>
    </tr>
    <? }
       $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY uname");
       while ($db->next_record()) {
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '4' %s", $qtag));
         $res   = $db2->num_rows();
         $db2->free();
         $db2->query(sprintf("SELECT * FROM bugs WHERE assigned = '" . $db->record['uid'] . "' AND status = '6' %s", $qtag));
         $clo   = $db2->num_rows();
         $db2->free();
         
         $tot = $res + $clo;
         
         if ($tot > 0) {
    ?>
    <tr>
      <td width="30%">
        <? print($db->record['email']); ?>
      </td>
      <td width="10%" align="center">
        <? print($res); ?>
      </td>
      <td width="10%" align="center">
        <? print($clo); ?>
      </td>
      <td width="10%" align="center">
        <? print($tot); ?>
      </td>
    </tr>
    <?   }
       } ?>
  </table>
<?
  d_DrawFooter();

?>
