<? 
   // Anthill
   // $Id: textreport.php,v 1.9 2003/09/10 22:50:55 vdanen Exp $

   // Create the headers; define a date in the past, always modified
   header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
   header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
   header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
   header("Cache-Control: post-check=0, pre-check=0", false);
   header("Pragma: no-cache");                                    // HTTP/1.0

   // set variables
   if (isset($_REQUEST['repval'])) { $repval = $_REQUEST['repval']; } else { $repval = NULL; }

   if (isset($repval)) {
     if ($repval == "total") {
       header("Content-type: application/octet-stream");
       header("Content-Disposition: attachment; filename=" . $repval . ".txt");
     }
  }

  include("include.php");
  if (!isset($repval)) {
    d_StartPage(gettext("Text Bug Reports"));
  }

  if (do_checkaccess($config['newusers'], $_USER['uid'], $_USER['uname']) == 1) exit;

  if (!isset($repval)) {
    d_DrawNav($user['uname']);
    d_DrawHeader(gettext("Select Report"));
?>
    <form method="post" action="textreport.php">
    <table border="0" cellpadding="0" cellspacing="0" width="40%" align="center">
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Select Report")); ?>:
        </td>
        <td width="50%">
          <select name="repval">
            <option value="total">Total</option>
            <option value="partial">Partial</option>
          </select>
        </td>
      </tr>
      <tr>
        <td width="50%">
          &nbsp;
        </td>
        <td width="50%">
          <input type="submit" value="<? print(gettext("Continue")); ?>">
        </td>
      </tr>
    </table>
    </form>
<?
    d_DrawFooter();
    exit;
  }

  $db2         = new db_Sql();
  $db2->host   = $_CONF['db_host'];
  $db2->dbase  = $_CONF['db_name'];
  $db2->user   = $_CONF['db_user'];
  $db2->passwd = $_CONF['db_pw'];
  $db2->connect();

  $date = gmdate(sprintf("%s %s", $_CONF['datefmt'], $_CONF['timefmt']));
  switch($repval) {
    case "total":
      if(file_exists($_CONF['incdir'] . "/reportengine.php")) {
        include_once($_CONF['incdir'] . "/reportengine.php");
      }
      report_init(58, 80, 1, 0, gettext("Total bug information report"), 2, 2);
      $db->query("SELECT bid,
        u2.name as assigned_user,
        severity_d.name as severity_name,
        status_d.name as status_name,
        creation,
        modified,
        shortdesc,
        priority_d.name priority_name,
        products.name as product_name,
        users.name as reporter_user,
        versions.name as version_name,
        components.name as component_name,
        IFNULL(resolve_d.name,\"UNRESOLVED\") as resolve_info,
        cc,
        case private when 0 then \"Public\" when 1 then \"Private\" else \"Unknown\" end,
        url
        FROM 
        bugs,
        priority_d,
        users,
        users as u2,
        severity_d,
        status_d,
        versions,
        products,
        components
        LEFT JOIN 
        resolve_d 
        ON
        (bugs.resolution = resolve_d.id)
        WHERE 
        (bugs.priority = priority_d.id)
        and (bugs.reporter = users.uid)
        and (bugs.assigned = u2.uid)
        and (bugs.severity = severity_d.id)
        and (bugs.status = status_d.id)
        and (bugs.version = versions.vid)
        and (bugs.product = products.pid)
        and (bugs.component = components.cid)
        ORDER BY 
        bid;");
        while ($db->next_record()) {
          report_que_line("");
          report_que_line(gettext("Bug      Priority Severity    Status      Modified              Resolution"));
          $cdate = d_getTimeGMT($db->record['creation']);
          $mdate = d_getTimeGMT($db->record['modified']);
          report_que_line(sprintf("%-8d %-8s %-11s %-11s %-21s %-8s", 
            $db->record['bid'],
            $db->record['priority_name'],
            $db->record['severity_name'],
            $db->record['status_name'],
            $mdate,
            $db->record['resolve_info']));
// some gettext length magic
          report_que_line(sprintf("        Assignee: %s", $db->record['assigned_user']));
          report_que_line(sprintf("        Reporter: %s", $db->record['reporter_user']));
          report_que_line(sprintf("         Created: %s", $cdate));
          report_que_line(sprintf("         Product: %s", $db->record['product_name']));
          report_que_line(sprintf("       Component: %s", $db->record['component_name']));
          report_que_line(sprintf("         Version: %s", $db->record['version_name']));
          report_que_line(sprintf(" Bug Description: %s", stripslashes($db->record['shortdesc'])));
          if (strlen($db->record['url'])>0) {
            report_que_line(sprintf("URL: %s", stripslashes($db->record['url'])));
          }
         $db2->query("SELECT description, date, users.name as uname FROM bugdesc, users WHERE (bid='" . $db->record['bid'] . "') AND (bugdesc.user = users.uid) ORDER BY date");
         $firsttime = 1;
         while ($db2->next_record()) {
           if ($firsttime == 1) {
             report_que_line(gettext("Long description:"));
             $firsttime = 0;
           } else {
             $xdate = d_getTimeGMT($db2->record['date']);
             report_que_line(sprintf("On %s, %s said:",$xdate,$db2->record['uname']));
           }
           $outstring = ereg_replace("  "," ",ereg_replace("\n"," ",ereg_replace("\r","", stripslashes($db2->record['description']))));
           report_flowtext($outstring,2);
         }
         $db2->free();

         $db2->query("SELECT date, what, oldval, newval, name FROM bugactivity, users WHERE (bid = '" . $db->record['bid'] . "') AND (bugactivity.user = users.uid) ORDER BY date");
         while ($db2->next_record()) {
           report_que_line("");
           report_que_line(sprintf(" Who: %s", $db2->record['name']));
           switch($db2->record['what']) {
             case 0:
               report_que_line(gettext("What: Status Change")); break;
             case 1:
               report_que_line(gettext("What: Reassigned")); break;
             case 2:
               report_que_line(gettext("What: State Change")); break;
             case 3:
               report_que_line(gettext("What: Added to CC")); break;
             case 4:
               report_que_line(gettext("What: Removed from CC")); break;
           }
// more gettext length magic
           report_que_line(sprintf(" Old: %s", $db2->record['oldval']));
           report_que_line(sprintf(" New: %s", $db2->record['newval']));
           report_que_line(sprintf("When: %s", d_getTimeGMT($db2->record['date'])));
         }
         
         report_que_line("");
       }
       report_que_line(sprintf(gettext("Report generated on %s GMT."), $date));

       report_finish();
       break;
    case "partial":
       d_DrawNav($user['uname']);
       d_DrawHeader(gettext("Partial bug information report"));
       printf("Partial bug information report not implemented\n");
       d_DrawFooter();
       break;
  }

?>
