<?
  // Anthill
  // $Id: createattachment.php,v 1.17 2003/08/27 20:56:38 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['bug']))             { $bug         = $_REQUEST['bug']; }             else { $bug         = NULL; }
  if (isset($_REQUEST['doit']))            { $doit        = $_REQUEST['doit']; }            else { $doit        = NULL; }
  if (isset($_REQUEST['type']))            { $type        = $_REQUEST['type']; }            else { $type        = NULL; }
  if (isset($_REQUEST['description']))     { $description = $_REQUEST['description']; }     else { $description = NULL; }
  if (isset($_FILES['afile']['size']))     { $afile_size  = $_FILES['afile']['size']; }     else { $afile_size  = NULL; }
  if (isset($_FILES['afile']['name']))     { $afile_name  = $_FILES['afile']['name']; }     else { $afile_name  = NULL; }
  if (isset($_FILES['afile']['tmp_name'])) { $afile       = $_FILES['afile']['tmp_name']; } else { $afile       = NULL; }
  if (isset($_FILES['afile']['type']))     { $afile_type  = $_FILES['afile']['type']; }     else { $afile_type  = NULL; }
  if (isset($_FILES['afile']['error']))    { $afile_error = $_FILES['afile']['error']; }    else { $afile_error = NULL; }

  d_StartPage(gettext("Upload Attachment"));
  d_DrawNav($_USER['uname']);
  d_DrawHeader(gettext("Upload Attachment"));

  $db->query("SELECT * FROM bugs WHERE bid = $bug");
  $db->next_record();
  $private = $db->record['private'];
  $db->free();

  if ($private == 1 && !isset($_USER['uid'])) {
      print(gettext("The bug you selected is marked private and is not available to unregistered users."));
      d_DrawFooter();
      exit;
  }

  if (isset($doit)) { // attachment to upload
    if ($description == "") {
      print("<p>" . gettext("You need to enter a description of the attachment.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if ($type == "") {
      print("<p>" . gettext("You need to enter a MIME type.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if ($afile_error == "4") { // UPLOAD_ERR_NO_FILE
      print("<p>" . gettext("No attachment uploaded.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if ($afile_size == 0) {
      print("<p>" . gettext("The attachment uploaded is zero bytes.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if ($afile_error == "2") { // UPLOAD_ERR_FORM_SIZE
      print("<p>" . gettext("The attachment uploaded is too large.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if ($afile_error == 1) { // UPLOAD_ERR_INI_SIZE
      print("<p>" . gettext("The attachment is larger than the system-wide maximum upload file size.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if ($afile_error == 3) { //UPLOAD_ERR_PARTIAL
      print("<p>" . gettext("The attachment was not completely uploaded.") . "</p>");
      d_DrawFooter();
      exit;
    }
    if (!is_uploaded_file($afile)) {
      print("<p>" . gettext("The attachment was not uploaded... possible file upload attack?") . "</p>");
      d_DrawFooter();
      exit;
    }
    // final safety check
    if ($afile_error != 0) {
      print("<p>" . gettext("There was an unknown error with your attachment upload.") . "</p>");
      d_DrawFooter();
      exit;
    }

    // get the next name for the attachment
    $db->query("SELECT * FROM attachidx");
    if ($db->num_rows() == 0) {
      $count = 1;
      $nextattach = 1;
    } else {
      while ($db->next_record()) {
        $count = $db->record['atid'];
      }
      $count++;
      $nextattach = $count;
    }
    $db->free();
    $newfile = $_CONF['root'] . $_CONF['attachdir'] . "/" . $nextattach;
    // make sure the file doesn't exist
    if (is_file($newfile)) {
      // if it does, try to increment by one.. if that fails, send error
      $count++;
      $nextattach = $count;
      $newfile = $_CONF['root'] . $_CONF['attachdir'] . "/" . $nextattach;
      if (is_file($newfile)) {
        print("<p>" . gettext("ERROR: Attachment filename already exists.  Upload aborted.") . "</p>");
        print("<p>" . gettext("Please notify the administrator of this site of this error.") . "</p>");
        d_DrawFooter();
        exit;
      }
    }

    $newfile = $_CONF['root'] . $_CONF['attachdir'] . "/" . $nextattach;
    if (!move_uploaded_file($afile, $newfile)) {
      print("<p>" . gettext("Problem copying attachment.  Aborting.") . "</p>");
      d_DrawFooter();
      exit;
    }

    $update = date("YmdHis");
    $fname  = $afile_name;
    if ($type == "patch") {
      $type = "text/plain";
    }
    if ($type == "othertype") {
      $type = $othertype;
    }
    if (!ereg("^([a-z-]+)/([a-z-]+)$", $type)) {
      print("<p>" . sprintf(gettext("You must select a legal mime type.  '<i>%s</i>' is not acceptable."), $type) . "</p>");
      d_DrawFooter();
      exit;
    }

    $fp   = fopen($newfile, "r");
    $data = fread($fp, filesize($newfile));
    fclose($fp);

    print("<p>" . gettext("Attachment uploaded successfully!") . "</p>");

    $url   = sprintf("showattachment.php?id=%s", $nextattach);
    $cmnt  = sprintf(gettext("<a href=\"%s\">Created an attachment (id=%s)</a>\n"), $url, $nextattach);
    $cmnt2 = gettext("Description of attachment") . " #$nextattach: " . $description;

    $query  = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
    $query .= "(NULL,'$bug','" . $_USER['uid'] . "',NULL,1,";
    $query .= "'" . addslashes($cmnt) . "')";
    $db->query($query);
    $db->free();
    $query  = "INSERT INTO bugdesc (did, bid, user, date, system, description) VALUES ";
    $query .= "(NULL,'$bug','" . $_USER['uid'] . "',NULL,0,";
    $query .= "'" . addslashes($cmnt2) . "')";
    $db->query($query);
    $db->free();

    $query  = "INSERT INTO bugactivity (aid, bid, user, date, what) ";
    $query .= "VALUES (NULL, '$bug', '" . $_USER['uid'] . "', ";
    $query .= "NULL, '5')";
    $db->query($query);
    $db->free();

    $query  = "INSERT INTO attachidx (atid, bid, date, mimetype, filename, user)";
    $query .= " VALUES ('$nextattach', '$bug', '$update', '$type', '$fname', ";
    $query .= "'" . $_USER['uid'] . "')";
    $db->query($query);
    $db->free();

    d_doDiff($bug);

    print("<p><a href=\"query.php?bug=$bug\">" . sprintf(gettext("Return to bug #%s"), $bug) . "</a>.</p>");

    d_DrawFooter();

  } else {
    if (!isset($bug)) {
      print("<p>" . gettext("Error: you must select a bug to associate attachment with!") . "</p>");
      d_DrawFooter();
      exit;
    }

    $db->query("SELECT * FROM bugs WHERE bid = '$bug'");
    $db->next_record();

    // if status RESOLVED or CLOSED and not owner or admin, disallow
    // creating attachments
    if ($db->record['status'] == "4" || $db->record['status'] == "6") {
      if ($_USER['uid'] != $db->record['assigned'] || $_USER['access'] < $config['adminac']) {
        print("<p>" . gettext("This bug is CLOSED or RESOLVED and you may not create an attachment.") . "</p>");
        d_DrawFooter();
        exit;
      }
    }

    if (!isset($_USER['uid'])) { // not logged in
      print("<p>" . gettext("You must be logged in first.") . "</p>");
      d_DrawFooter();
      exit;
    }

    d_DrawCAttach($bug);

    d_DrawFooter(); 
  } 
?>
