<?
  // Anthill
  // $Id: editproducts.php,v 1.27 2003/09/24 06:15:36 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['action']))      { $action      = $_REQUEST['action']; }      else { $action      = NULL; }
  if (isset($_REQUEST['name']))        { $name        = $_REQUEST['name']; }        else { $name        = NULL; }
  if (isset($_REQUEST['description'])) { $description = $_REQUEST['description']; } else { $description = NULL; }
  if (isset($_REQUEST['pid']))         { $pid         = $_REQUEST['pid']; }         else { $pid         = NULL; }

  d_StartPage(gettext("Select Product"));

  if (!do_checkacs($_USER['access'])) exit;

  d_DrawNav($_USER['uname']);

  // form to add new product
  if ($action == "add") {
    d_DrawHeader(gettext("Add Product"));
    d_DrawEditProd("insert",0);
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // insert new product
  if ($action == "insert") {
    d_DrawHeader(gettext("Add Product"));
    // make sure product doesn't already exist
    $db->query("SELECT * FROM products WHERE (name = '$name') AND (deleted = '0')");
    if ($db->num_rows() > 0) {
      print("<p>" . gettext("A product by this name already exists.") . "</p>");
    } else {
      if ($name == "") {
        print("<p>" . gettext("ERROR: You submitted an empty field.") . "</p>");
      } else {
        $query  = "INSERT INTO products (pid, name, description) VALUES ";
        $query .= "(NULL, '" . addslashes($name) . "', '";
        $query .= addslashes(htmlspecialchars($description)) . "')";
        $db->query($query);
        $db->free();
        print("<span class=\"text\"><center>" . gettext("Product added successfully") . "</center></span>");
      }
    }
    print("<p>" . gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // form to delete product
  if ($action == "del") {
    d_DrawHeader(gettext("Delete Product"));
    $db->query("SELECT * FROM products WHERE pid = '$pid'");
    $db->next_record();
    $db->free();
?>
  <form method="post" action="editproducts.php">
  <p><? print(sprintf(gettext("Are you sure you want to delete the product <b>%s</b>?"), stripslashes($db->record['name']))); ?>
  </p>
  <input type="submit" value="<? print(gettext("Delete")); ?>">
  <input type="hidden" name="pid" value="<? print($pid); ?>">
  <input type="hidden" name="action" value="delete">
  </form>
<?
    d_DrawFooter();
    exit;
  }

  // perform "delete"
  if ($action == "delete") {
    d_DrawHeader(gettext("Delete Product"));
    $db->query("UPDATE products SET deleted = '1' WHERE pid = '$pid'");
    $db->free();
    print("<span class=\"text\"><center>" . gettext("Product removed.") . "</center></span>");
    print("<p>" . gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // form to edit product
  if ($action == "edit") {
    d_DrawHeader(gettext("Change Product"));
    d_DrawEditProd("change",$pid);
?>
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="50%" align="right" valign="top">
          <a href="editcomponents.php?pid=<? print($pid); ?>"><? print(gettext("Edit components")); ?>:</a>
        </td>
        <td width="50%">
          <? $db->query("SELECT * FROM components WHERE (product = '$pid') AND (deleted = '0') ORDER BY name");
             while ($db->next_record()) {
               print(sprintf("<b>%s</b>: %s<br />",stripslashes($db->record['name']),stripslashes($db->record['description'])));
             }
             $db->free();
          ?>
        </td>
      </tr>
      <tr>
        <td width="50%" align="right" valign="top">
          <a href="editversions.php?pid=<? print($pid); ?>"><? print(gettext("Edit versions")); ?>:</a>
        </td>
        <td width="50%">
          <? $db->query("SELECT * FROM versions WHERE (product = '$pid') AND (deleted = '0') ORDER BY name");
             while ($db->next_record()) {
               print(sprintf("<b>%s</b><br />",$db->record['name']));
             }
             $db->free();
          ?>
        </td>
      </tr>
    </table>
<?
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // change product
  if ($action == "change") {
    d_DrawHeader(gettext("Change Product"));
    $query  = "UPDATE products SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE pid = '$pid'";
    $db->query($query);
    $db->free();
    $query  = "UPDATE products SET description = '" . addslashes(htmlspecialchars($description)) . "' ";
    $query .= "WHERE pid = '$pid'";
    $db->query($query);
    $db->free();
    print("<span class=\"text\"><center>" . gettext("Product changed.") . "</center></span>");
    print("<p>" . gettext("Return to <a href=\"editproducts.php\">products and components</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // default action
  d_DrawHeader(gettext("Select Product"));

  $db2         = new db_Sql();
  $db2->host   = $_CONF['db_host'];
  $db2->dbase  = $_CONF['db_name'];
  $db2->user   = $_CONF['db_user'];
  $db2->passwd = $_CONF['db_pw'];
  $db2->connect();

  $db->query("SELECT * FROM products WHERE deleted = '0' ORDER BY name ASC");

?>
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr bgcolor="<? print($config['barcol1']); ?>">
      <td width="20%">
        <? print(gettext("Product")); ?>
      </td>
      <td width="60%">
        <? print(gettext("Description")); ?>
      </td>
      <td width="10%">
        <? print(gettext("Bugs")); ?>
      </td>
      <td width="10%">
        <? print(gettext("Action")); ?>
      </td>
    </tr>
<?
  while ($db->next_record()) {
    $pid = $db->record['pid'];
?>
    <tr>
      <td width="20%">
        <? print(sprintf("<a href=\"editproducts.php?pid=%s&action=edit\">%s</a>",$pid,stripslashes($db->record['name']))); ?>  
      </td>
      <td width="60%">
        <? print(stripslashes($db->record['description'])); ?>
      </td>
      <td width="10%">
        <? $db2->query("SELECT * FROM bugs WHERE product='$pid'");
           $bugs  = $db2->num_rows();
           print($bugs);
        ?>
      </td>
      <td width="10%">
        <? print("<a href=\"editproducts.php?pid=$pid&action=del\">" . gettext("Delete") . "</a>"); ?>
      </td>
    </tr>
<?
  }
  $db->free();
?>
    <tr>
      <td colspan="3" width="90%">
        <? print(gettext("Add a new product")); ?>
      </td>
      <td width="10%">
        <a href="editproducts.php?action=add"><? print(gettext("Add")); ?></a>
      </td>
    </tr>
  </table>

  <p><? print(gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.")); ?></p>

<?
  d_DrawFooter();
?>
