<?
  // Anthill
  // $Id: editusers.php,v 1.26 2003/08/27 19:59:25 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['action']))    { $action    = $_REQUEST['action']; }    else { $action    = NULL; }
  if (isset($_REQUEST['moduserid'])) { $moduserid = $_REQUEST['moduserid']; } else { $moduserid = NULL; }
  if (isset($_REQUEST['name']))      { $name      = $_REQUEST['name']; }      else { $name      = NULL; }
  if (isset($_REQUEST['uname']))     { $uname     = $_REQUEST['uname']; }     else { $uname     = NULL; }
  if (isset($_REQUEST['email']))     { $email     = $_REQUEST['email']; }     else { $email     = NULL; }
  if (isset($_REQUEST['access']))    { $access    = $_REQUEST['access']; }    else { $access    = NULL; }
  if (isset($_REQUEST['pass1']))     { $pass1     = $_REQUEST['pass1']; }     else { $pass1     = NULL; }
  if (isset($_REQUEST['pass2']))     { $pass2     = $_REQUEST['pass2']; }     else { $pass2     = NULL; }
  if (isset($_REQUEST['owner']))     { $owner     = $_REQUEST['owner']; }     else { $owner     = NULL; }
  if (isset($_REQUEST['bugowner']))  { $bugowner  = $_REQUEST['bugowner']; }  else { $bugowner  = NULL; }

  d_StartPage(gettext("Select User"));

  if (!do_checkacs($_USER['access'])) exit;

  d_DrawNav($_USER['uname']);

  // form to delete user
  if ($action == "del") {
    d_DrawHeader(gettext("Delete User"));
    $db->query("SELECT * FROM users WHERE uid = '$moduserid'");
    $db->next_record();
    $db->free();
    if ($db->record['uid'] == 1) {
      print("<p>" . gettext("You cannot delete the administrator account.") . "</p>");
      d_DrawFooter();
      exit;
    }
    print("<form method=\"post\" action=\"editusers.php\">");
    print("<p>" . sprintf(gettext("Are you sure you want to delete the user <b>%s</b>?"), stripslashes($db->record['name'])) . "</p>");
    // check if this user owns any components
    $db->query("SELECT * FROM components WHERE (owner = '$moduserid') AND (deleted = '0')");
    if ($db->num_rows() > 0) {
      print("<p>" . gettext("This user owns the following components:") . "</p>");
      while ($db->next_record()) {
        print("<b>" . $db->record['name'] . "</b><br />");
      }
      $db->free();
      print("<p>" . gettext("If you want to delete this user, you should reassign their components to someone else.") . "</p>");
      print("<p>" . gettext("Select a new component owner:") . "</p>");
      print("<select name=\"owner\" value=\"1\">");
      $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0')");
        while ($db->next_record()) {
          $user = $db->record;
          print(sprintf("<option value=\"%s\">%s</option>\n",$user['uid'],$user['email']));
        }
      print("</select>");
    }
    // check if this user owns any bugs
    $db->query("SELECT * FROM bugs WHERE assigned = '$moduserid'");
    if ($db->num_rows() > 0) {
      $db2         = new db_Sql();
      $db2->host   = $_CONF['db_host'];
      $db2->dbase  = $_CONF['db_name'];
      $db2->user   = $_CONF['db_user'];
      $db2->passwd = $_CONF['db_pw'];
      $db2->connect();
      print("<p>" . gettext("This user owns the following bugs:") . "</p>");
      while ($db->next_record()) {
        $db2->query("SELECT name FROM status_d WHERE id = '" . $db->record['status'] . "'");
        $db2->next_record();
        $status = $db2->record['name'];
        $db2->free();
        print(sprintf("<b>%s</b>: %s (%s)<br />",$db->record['bid'], $db->record['shortdesc'], $status));
      }
      $db->free();
      print("<p>" . gettext("If you want to delete this user, you should reassign their bugs to someone else.") . "</p>");
      print("<p>" . gettext("Select a new component owner:") . "</p>");
      print("<select name=\"bugowner\" value=\"1\">");
      $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0')");
        while ($db->next_record()) {
          $user = $db->record;
          print(sprintf("<option value=\"%s\">%s</option>\n",$user['uid'],$user['email']));
        }
      print("</select>");
    }
    print("<br /><br /><input type=\"submit\" value=\"" . gettext("Delete User") . "\">");
    print("<input type=\"hidden\" name=\"moduserid\" value=\"$moduserid\">");
    print("<input type=\"hidden\" name=\"action\" value=\"delete\">");
    print("</form>");
    d_DrawFooter();
    exit;
  }

  // perform delete (we don't actually really delete the user)
  if ($action == "delete") {
    d_DrawHeader(gettext("Delete User"));
    $db->query("UPDATE users SET deleted = '1' WHERE uid = '$moduserid'");
    $db->free();
    print("<span class=\"text\"><center>" . gettext("User removed.") . "</center></span>");
    if (isset($owner)) {
      $db->query("UPDATE components SET owner = '$owner' WHERE (owner = '$moduserid') AND (deleted = '0')");
      $db->free();
      print("<p>" . gettext("Components re-assigned.") . "</p>");
    }
    if (isset($bugowner)) {
      $db->query("UPDATE bugs SET assigned = '$bugowner' WHERE assigned = '$moduserid'");
      $db->free();
      print("<p>" . gettext("Bugs re-assigned.") . "</p>");
    }
    print("<p>" . gettext("Return to <a href=\"editusers.php\">user list</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // form to edit user
  if ($action == "edit") {
    d_DrawHeader(gettext("Edit User"));
    d_DrawEditUser($moduserid);
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // change user
  if ($action == "change") {
    d_DrawHeader(gettext("Edit User"));
    $query  = "UPDATE users SET name = '" . addslashes(htmlspecialchars($name)) . "' ";
    $query .= "WHERE uid = '$moduserid'";
    $db->query($query);
    $db->free();
    $query  = "UPDATE users SET uname = '" . addslashes(htmlspecialchars($uname)) . "' ";
    $query .= "WHERE uid = '$moduserid'";
    $db->query($query);
    $db->free();
    $query  = "UPDATE users SET email = '" . addslashes(htmlspecialchars($email)) . "' ";
    $query .= "WHERE uid = '$moduserid'";
    $db->query($query);
    $db->free();
    $db->query("UPDATE users SET access = '$access' WHERE uid = '$moduserid'");
    $db->free();

    if ($pass1 != "") {
      if ($pass1 == $pass2) {
        $cpass  = md5($pass1);
        $query  = "UPDATE users SET passwd = '" . $cpass . "' ";
        $query .= "WHERE uid = '$moduserid'";
        $db->query($query);
        $db->free();
      } else {
        print("<span class=\"text\"><font color=\"red\"><center>" . gettext("Passwords do not match; no change to user's password.") . "</center></font></span>");
      }
    }

    print("<span class=\"text\"><center>" . gettext("User information changed.") . "</center></span>");
    print("<p>" . gettext("Return to <a href=\"editusers.php\">user list</a>.") . "</p>");
    print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
    d_DrawFooter();
    exit;
  }

  // default action
  d_DrawHeader(gettext("Select User"));
  $db->query("SELECT * FROM users WHERE deleted = '0'");

?>
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr bgcolor="<? print($config['barcol1']); ?>">
      <td width="5%">
        <? print(gettext("User ID")); ?>
      </td>
      <td width="15%">
        <? print(gettext("Real Name")); ?>
      </td>
      <td width="10%">
        <? print(gettext("User Name")); ?>
      </td>
      <td width="30%">
        <? print(gettext("Email Address")); ?>
      </td>
      <td width="20%">
        <? print(gettext ("Last Login")); ?>
      </td>
      <td width="10%">
        <? print(gettext("Access Level")); ?>
      </td>
      <td width="10%" align="right">
        <? print(gettext("Action")); ?>
      </td>
    </tr>
<?
  while ($db->next_record()) {
?>
    <tr>
      <td width="5%">
        <? print($db->record['uid']); ?>
      </td>
      <td width="15%">
        <? print(sprintf("<a href=\"editusers.php?moduserid=%s&action=edit\">%s</a>",$db->record['uid'],stripslashes($db->record['name']))); ?>  
      </td>
      <td width="10%">
        <? print($db->record['uname']); ?>
      </td>
      <td width="30%">
        <? print($db->record['email']); ?>
      </td>
      <td width="20%">
        <? print($db->record['laston']); ?>
      </td>
      <td width="10%">
        <? print($db->record['access']); ?>
      </td>
      <td width="10%" align="right">
        <? print(sprintf("<a href=\"editusers.php?moduserid=%s&action=del\">" . gettext("Delete") . "</a>",$db->record['uid'])); ?>
      </td>
    </tr>
<?
  }
?>
    <tr>
      <td width="20%" colspan="2">
        <? print(gettext("Add a new user")); ?>
      </td>
      <td width="10%">
        <a href="newuser.php?admin=1"><? print(gettext("Add")); ?></a>
      </td>
    </tr>
  </table>

<?
  print("<p>" . gettext("Return to <a href=\"admin.php\">Anthill Preferences</a>.") . "</p>");
  d_DrawFooter();
?>