<?
  // Anthill
  // $Id: enterbug.php,v 1.30 2003/08/27 02:36:56 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['reporter']))  { $reporter  = $_REQUEST['reporter']; }  else { $reporter  = NULL; }
  if (isset($_REQUEST['version']))   { $version   = $_REQUEST['version']; }   else { $version   = NULL; }
  if (isset($_REQUEST['component'])) { $component = $_REQUEST['component']; } else { $component = NULL; }
  if (isset($_REQUEST['prior']))     { $prior     = $_REQUEST['prior']; }     else { $prior     = NULL; }
  if (isset($_REQUEST['sever']))     { $sever     = $_REQUEST['sever']; }     else { $sever     = NULL; }
  if (isset($_REQUEST['assigned']))  { $assigned  = $_REQUEST['assigned']; }  else { $assigned  = NULL; }
  if (isset($_REQUEST['shortdesc'])) { $shortdesc = $_REQUEST['shortdesc']; } else { $shortdesc = NULL; }
  if (isset($_REQUEST['url']))       { $url       = $_REQUEST['url']; }       else { $url       = NULL; }
  if (isset($_REQUEST['longdesc']))  { $longdesc  = $_REQUEST['longdesc']; }  else { $longdesc  = NULL; }
  if (isset($_REQUEST['product']))   { $product   = $_REQUEST['product']; }   else { $product   = NULL; }
  if (isset($_REQUEST['pid']))       { $pid       = $_REQUEST['pid']; }       else { $pid       = NULL; }
  if (isset($_REQUEST['ebug']))      { $ebug      = $_REQUEST['ebug']; }      else { $ebug      = NULL; }

  d_StartPage(gettext("Submit a Bug"));
  d_DrawNav($_USER['uname']);
  d_DrawHeader(gettext("Submit a Bug"));
  
  if ($config['showrules'] == "1") {
    if (!isset($ebug) && !isset($pid)) {  // show the rules for entering a report
      d_DrawRules();
      d_DrawFooter();
      exit;
    }
  }

  $db->query("SELECT * FROM products");
  if ($db->num_rows() == 1) {
    $db->next_record();
    $pid = $db->record['pid'];
  }
  $db->free();

  if (!isset($pid)) {
?>

  <p><b><? print(gettext("You must first select a product in which to enter your new bug")); ?>:</b></p>

  <table border="0" cellpadding="2" cellspacing="0">
    <?  $db->query("SELECT * FROM products WHERE deleted = '0' ORDER BY name");
        while ($db->next_record()) {
    ?>
          <tr>
            <td width="20%" align="right">
              <a href="enterbug.php?pid=<? print($db->record['pid']); ?>"><? print($db->record['name']); ?></a>:
            </td>
            <td width="80%">
              <? print(stripslashes($db->record['description'])); ?>
            </td>
          </tr>
    <?
        }
        $db->free();
    ?>
    </tr>
  </table>

<?
  } else {
    if (!isset($_USER['uid'])) {
      // this is anonymous user; no posting permitted
      print("<p>" . gettext("You must login first if you wish to submit a bug.") . "</p>");
      d_DrawFooter();
      exit;
    }
?>

  <p><? print(gettext("This page lets you enter a new bug into Anthill.")); ?></p>

  <form method="post" action="postbug.php">
  <table border="0" cellpadding="0" cellspacing="0">
    <tr>
      <td width="10%" align="right">
        <b><? print(gettext("Reporter")); ?>:</b>
      </td>
      <td width="40%">
        <? print($_USER['email']); ?>
        <input type="hidden" name="reporter" value="<? print($_USER['uid']); ?>">
      </td>
      <td width="10%" align="right">
        <b><? print(gettext("Product")); ?>:</b>
      </td>
      <td width="40%">
        <?  $db->query("SELECT * FROM products WHERE pid = '$pid'");
            $db->next_record();
            print($db->record['name']);
            $db->free();
        ?>
      </td>
    </tr>
    <tr>
      <td width="10%" align="right">
        <b><? print(gettext("Version")); ?>:</b>
      </td>
      <td width="40%">
        <select name="version" size="5">
        <?  $db->query("SELECT * FROM versions WHERE (product = '$pid') AND (deleted = '0') ORDER BY name ASC");
            if ($db->num_rows() == 1) {
              $i = 0;
            }
            while ($db->next_record()) {
              if ($i == "0") {
                $selected = "SELECTED";
              } else {
                $selected = "";
              }
              print(sprintf("<option value=\"%s\" %s>%s</option>\n",$db->record['vid'],$selected,$db->record['name']));
              $i++;
            }
            $db->free();
        ?>
        </select>
      </td>
      <td width="10%" align="right">
        <b><? print(gettext("Component")); ?>:</b>
      </td>
      <td width="40%">
        <select name="component" size="5">
        <?  $db->query("SELECT * FROM components WHERE (product = '$pid') AND (deleted = '0') ORDER BY name");
            while ($db->next_record()) {
              print(sprintf("<option value=\"%s\">%s</option>\n",$db->record['cid'],$db->record['name']));
            }
            $db->free();
        ?>
        </select>
      </td>
    </tr>
    <tr>
      <td width="10%" align="right">
        <b><? print(gettext("Resolution Priority")); ?>:</b>
      </td>
      <td width="40%">
        <select name="prior">
        <?  $db->query("SELECT * FROM priority_d");
            while ($db->next_record()) {
              if ($db->record['s_def'] == 1) {
                $def = "SELECTED";
              } else {
                $def = "";
              }
              print(sprintf("<option value=\"%s\" %s>%s</option>\n",$db->record['id'],$def,$db->record['name']));
            }
            $db->free();
        ?>
        </select>
      </td>
      <td width="10%" align="right">
        <b><? print(gettext("Severity")); ?>:</b>
      </td>
      <td width="40%">
        <select name="sever">
        <?  $db->query("SELECT * FROM severity_d");
            while ($db->next_record()) {
              if ($db->record['s_def'] == 1) {
                $def = "SELECTED";
              } else {
                $def = "";
              }
              print(sprintf("<option value=\"%s\" %s>%s</option>\n",$db->record['id'],$def,$db->record['name']));
            }
            $db->free();
        ?>
        </select>
      </td>
    </tr>
    <tr>
      <td width="10%" align="right">
        <b><? print(gettext("Assigned To")); ?>:</b>
      </td>
      <td colspan="3" width="90%">
        <select name="assigned" size="5">
        <?  $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0') ORDER BY uname");
            print("<option value=\"0\">" . gettext("Owner of Component") . "</option>");
            while ($db->next_record()) {
              print(sprintf("<option value=\"%s\">%s</option>\n",$db->record['uid'],$db->record['email']));
            }
            $db->free();
        ?>
        </select> <span class="tiny">(<? print(gettext("Leave at default to assign to component owner")); ?>)</span>
      </td>
    </tr>
    <tr>
      <td width="10%" align="right">
        <b><? print(gettext("Summary")); ?>:</b>
      </td>
      <td colspan="3" width="90%">
        <input type="text" name="shortdesc" size="76" maxlength="100">
      </td>
    </tr>
    <tr>
      <td width="10%" align="right">
        <b>URL:</b>  (<? print(gettext("include prefix")); ?>)
      </td>
      <td colspan="3" width="90%">
        <input type="text" name="url" size="76" maxlength="128">
      </td>
    </tr>
    <tr>
      <td width="10%" align="right">
        <b><? print(gettext("Description")); ?>:</b>
      </td>
      <td colspan="3" width="90%">
        <textarea name="longdesc" cols="76" rows="10" wrap="hard"></textarea>
      </td>
    </tr>
    <tr>
      <td width="10%" align="right">
        &nbsp;
      </td>
      <td colspan="3" width="90%">
        <input type="hidden" name="product" value="<? print($pid); ?>">
        &nbsp;&nbsp;&nbsp;&nbsp;
        <input type="submit" value="     <? print(gettext("Commit")); ?>     ">
        &nbsp;&nbsp;&nbsp;&nbsp;
        <input type="reset" value="<? print(gettext("Reset")); ?>">
  </table>
  </form>

<?

  }

  d_DrawFooter();
?>