<?
  // Anthill
  // $Id: newuser.php,v 1.36 2003/09/26 22:47:30 vdanen Exp $

  include("include.php");

  // set variables
  if (isset($_REQUEST['go']))    { $go    = $_REQUEST['go']; }    else { $go    = NULL; }
  if (isset($_REQUEST['email'])) { $email = $_REQUEST['email']; } else { $email = NULL; }
  if (isset($_REQUEST['uname'])) { $uname = $_REQUEST['uname']; } else { $uname = NULL; }
  if (isset($_REQUEST['rname'])) { $rname = $_REQUEST['rname']; } else { $rname = NULL; }

  d_StartPage(gettext("New User Registration"));

  // generate new password for existing user
  if ($go == "newpass") {
    // $email, $uname
    d_DrawNav($_USER['uname']);
    d_DrawHeader(gettext("New User Registration"));

    $db->query("SELECT * FROM users WHERE (uname = '$uname') AND (deleted='0')");
    $db->next_record();
    $user  = $db->record;
    $db->free();
    
    if (!isset($user['uname'])) {
      print("<p>" . gettext("The username supplied does not exist on this system.") . "</p>");
      d_DrawFooter();
      exit;
    }

    if ($user['email'] == $email) {
      $newpass  = do_newPass($uname);
      $cpass    = md5($newpass);
      $db->query("UPDATE users SET passwd = '$cpass' WHERE (uid=" . $user['uid'] . ") ");
      $db->free();

      // get the maximum string length to format the email nicely
      $msg[0]   = gettext("Login name");
      $msg[1]   = gettext("Password");
      $limit    = count($msg);
      $size     = 0;
      for ($i=0; $i < $limit; $i++) {
        if (strlen($msg[$i]) > $size) {
          $size = strlen($msg[$i]);
        }
      }
      for ($i=0; $i < $limit; $i++) {
        $buff = $size - strlen($msg[$i]);
        if ($buff > 0) {
          $msg[$i] = $msg[$i] . str_repeat(" ", $buff);
        }
      }

      $message  = gettext("In order to use Anthill, you must use the following to log in") . ":\n\n";
      $message .= $msg[0] . ": " . $user['uname'] . "\n";
      $message .= $msg[1] . ": " . $newpass . "\n\n";
      $message .= gettext("To change your password, log in and go to \"Preferences\".") . "\n";
      $message .= "\n--\n" . $_CONF['webroot'] . "\n";
      $retval   = @mail($user['name'] . " <" . $user['email'] . ">",
                  gettext("Your Anthill password") , $message,
                  "From: " . $config['mdaemon'] . " <" . $config['memail'] . ">\nReturn-Path: <" . $config['memail'] . ">\nX-Mailer: " . _NAME . " " . _VERSION);
      print("<p>" . sprintf(gettext("A new password has been emailed to %s."), $email) . "</p>");
    } else {
      print("<p>" . sprintf(gettext("The username you entered: <b>%s</b> does not match the supplied email address: <b>%s</b>."), $uname, $email));
      print(sprintf(gettext("Please go back and enter your proper email address and user name.  If you have forgotten your username, please email the <a href=\"mailto:%s\">administrator</a>."), $config['adminemail']) . "</p>");
    }
    d_DrawFooter();
    exit;
  }

  // generate new user
  if ($go == "newuser") {
    $msg = do_checkUser($uname, $email, 0, 0);
    if (!isset($msg)) {
      if (isset($_USER['uid']) && $_USER['access'] >= $config['adminac']) {
        $msg = "<span class=\"text\"><center>" . sprintf(gettext("Password has been emailed to %s.  You can return to <a href=\"editusers.php\">Edit User Preferences</a>."), $email);
      } else {
        $msg = "<span class=\"text\"><center>" . sprintf(gettext("Thank you for registering.  A password has been emailed to %s.  Use this password to log into %s."), $email, $config['sitename']) . "</center></span>";
      }

      $newpass  = do_newPass($uname);
      $now      = date(sprintf("%s %s",$_CONF['datefmt'],$_CONF['timefmt']));
      $cpass    = md5($newpass);

      $query    = "INSERT INTO users (uid, name, uname, email, passwd, ";
      $query   .= "access, laston) VALUES ";
      $query   .= "(NULL,'" . addslashes(htmlspecialchars($rname)) . "',";
      $query   .= "'" . addslashes(htmlspecialchars($uname)) . "',";
      $query   .= "'" . addslashes(htmlspecialchars($email)) . "',";
      $query   .= "'$cpass','1','$now') ";
      $db->query($query);
      $db->free();

      // get the maximum string length to format the email nicely
      $emsg[0]  = gettext("Login name");
      $emsg[1]  = gettext("Password");
      $limit    = count($emsg);
      $size     = 0;
      for ($i=0; $i < $limit; $i++) {
        if (strlen($emsg[$i]) > $size) {
          $size = strlen($emsg[$i]);
        }
      }
      for ($i=0; $i < $limit; $i++) {
        $buff = $size - strlen($emsg[$i]);
        if ($buff > 0) {
          $emsg[$i] = $emsg[$i] . str_repeat(" ", $buff);
        }
      }

      $message  = gettext("In order to use Anthill, you must use the following to log in") . ":\n\n";
      $message .= $emsg[0] . ": " . $uname . "\n";
      $message .= $emsg[1] . ": " . $newpass . "\n\n";
      $message .= gettext("To change your password, log in and go to \"Preferences\".") . "\n";
      $message .= "\n--\n" . $_CONF['webroot'] . "\n";
      $retval   = @mail($email,
                  gettext("Your Anthill password"), $message,
                  "From: " . $config['mdaemon'] . " <" . $config['memail'] . ">\nReturn-Path: <" . $config['memail'] . ">\nX-Mailer: " . _NAME . " " . _VERSION);
    }
    d_DrawNav($_USER['uname']);
    d_DrawHeader(gettext("New User Registration"));
    print($msg);

    d_DrawFooter();
    exit;
  }

  // load form
  d_DrawNav($_USER['uname']);
  d_DrawHeader(gettext("New User Registration"));

  if ($config['newusers'] == 1 || $admin == 1) {
    d_DrawNewUser();
  } else {
?>
  <p><? print(sprintf(gettext("We're sorry... this is a private site and new users must be added by the administrator.  Try sending an email to request access to <a href=\"mailto:%s\">%s</a>."), $config['adminemail'], $config['adminemail'])); ?></p>
<?
  }

  d_DrawFooter();
?>
